Last Comment Bug 12916 - Allow bounce/redirect of mail messages
: Allow bounce/redirect of mail messages
Status: NEW
: helpwanted
Product: MailNews Core
Classification: Components
Component: Composition (show other bugs)
: Trunk
: All All
: -- enhancement with 289 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
http://mailredirect.sourceforge.net
: 69135 125026 168497 216047 225522 230928 231777 236859 240976 242311 245492 262564 267758 274411 277096 278622 323249 333583 339791 389889 593439 (view as bug list)
Depends on:
Blocks: 11034
  Show dependency treegraph
 
Reported: 1999-08-31 18:07 PDT by Phil Peterson
Modified: 2016-01-06 02:47 PST (History)
164 users (show)
davida: blocking‑thunderbird3-
mscott: blocking‑thunderbird2-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Patch v0.1 (18.70 KB, patch)
2003-08-16 05:03 PDT, Luke Ross
no flags Details | Diff | Review
v0.02 (19.47 KB, patch)
2004-04-14 04:54 PDT, Wolfgang Rosenauer [:wolfiR]
no flags Details | Diff | Review
Bounce extension 0.0.3 (27.50 KB, application/x-xpinstall)
2004-07-30 02:25 PDT, Pawel Krzesniak
no flags Details
mailredirect extension working in TB 2.0 (103.48 KB, application/x-zip-compressed)
2007-04-20 23:23 PDT, Mattias Jiderhamn
no flags Details

Description Phil Peterson 1999-08-31 18:07:54 PDT
Here's a frequently requested feature:

     Subject: Messenger: Redirect Button
        Date: Tue, 31 Aug 1999 19:33:03 -0500
        From: Thomas Swan <tswan@sunset.backbone.olemiss.edu>
    Reply-To: tswan@olemiss.edu
Organization: The University of Mississippi
  Newsgroups: netscape.public.mozilla.wishlist

In our office, we have appointees for checking departmental email accounts.
These need to be redirected to other recipients for a
response.  Normal forwarding doesn't solve this.  When the proper recipient
receives the email and the "replies" to it, the "reply" is sent
to the secretary.  The work around is having to cut and paste addresses into and
out of the messages.  This is often time consuming,
not to mention aggravating.

Redirecting mail would sending as the original sender adding a notation of who
was doing the relaying.  Eudora Light and Eudora Pro have
this feature and it's the only reason why our office has not switch to another
email client [we would rather use messenger :) ].   I have
kept requesting this feature through normal channels, but it seems to have not
fallen on the right ears.   I would hope it would this time.

Thanks,
Thomas Swan
Comment 1 Thomas Swan 2000-03-23 20:52:51 PST
I hate to ask, if someone can give me a starting point (module etc.) I'll be 
happy to give a shot at implementing this feature.  I prefer not to just 
complain :)
Comment 2 Alan S. Jones 2000-03-23 21:24:13 PST
I am not sure on what modules are involved, but it seems like redirect (how 
Eudora does it) is a variation of forward with out putting things like ">" 
infront of the original message.  Then moving the from addres to the "To" line.

Maybe someone can point out where all that is hiding.

Comment 3 lchiang 2000-03-23 21:41:39 PST
You may want to ask in the mailnews newsgroup on news.mozilla.org to get an idea 
of which part of the code to look in first.  Thanks.
Comment 4 Thomas Swan 2000-03-23 22:46:05 PST
What Eudora does is as follows...  Also, it allows you to edit the message 
before sending it on, which I'm not sure I'm crazy about except that the person 
could put addtional instructions in there...

Anyway, the original message is copied without any forwarding marks > | a sample 
Header follows

From myname@myplace.com Fri Mar 24 00:33:24 2000
Return-Path: <myname@myplace.com>
Received: {lots of stuff}
X-Sender: myname@myplace.com
X-Mailer: {whatever}
Date: {Date}
To: newrecepient@someotherplace.com
From: Smoote <original@hisplace.com> (by way of Hawley <myname@myplace.com>)
Subject: {whatever}
Mime-Version: 1.0
Content-type: {standard stuff}

I agree with you on what would need to be done.  Essentionally a copy of the 
forward would work, changing instead of doing the call to set the From: value 
from the user's profile/preferences to the original senders address with the 
modifications and not modifying the messages contents with the "quote" markup...

I'll try the newsgroup... thanks...

P.S. I desperately want this in the mail/news client... :)~
Comment 5 Phil Peterson 2000-03-24 09:55:10 PST
tswan, that's great news -- thanks for volunteering to work on this!

I think the key features that "bounce" is similar to are Drafts or Edit Message
As New. You certainly need to whack the From header, but then you'll need to
decide how many of the original headers you need to maintain vs. the ones you
can let mozilla replace.

You might also reassign this bug to yourself.
Comment 6 Thomas Swan 2000-04-04 23:28:06 PDT
I don't believe this blocks Bug 11769.  This is entirely different and not 
filter based.  The definition of bounce in the summary is not to act as a rubber 
shield but to facilitate redirection of email to the proper recipients.  11769 
is a different beast entirely...

P.S. I'm still at a loss on where to begin, I've been thumbing through pages of 
code trying to follow a trace on the forward, and where to start modifying the 
code to allow for a redirect.  I'm scared from what I've seen so far is that the 
headers are generated from the current identity or the identity associated with 
the message.  I'm still looking...

If anyone has any additional pointers I would greatly appreciate it...

Comment 7 (not reading, please use seth@sspitzer.org instead) 2000-04-05 00:54:22 PDT
adding me, rhp and ducarroz to the cc list.  we'll help get thomas started.

it sounds like he really wants to contribute to mailnews.

reassign to tswan.
Comment 8 Thomas Swan 2000-04-07 16:21:55 PDT
Currently, going through source and finding areas that may need to be changed.  
Possibly starting a little hacking this weekend.  I'll put a status update in a 
little while.
Comment 9 (not reading, please use seth@sspitzer.org instead) 2000-04-07 16:35:40 PDT
Thomas, glad to have you hacking away!  let us know if you need help or have
questions.
Comment 10 Dan Mosedale (:dmose) 2000-07-26 11:35:18 PDT
As Phil points out, this is similar to the Drafts functionality.  Recently alecf
and I were contemplating one way to do this using Drafts to do most of the work
(which, not coincidentally, would make moderating a list easy in Mozilla).

Right now, if you refile a received message in Drafts and then instantiate it in
composer and send it, it attempts to use your default email address as the From:
line.  Instead of mapping an unknown From: header to the default, your code
could assume that an unknown From: header means "this is a redirect".  The
thought is that this probably would actually be pretty straightforward to code.
Comment 11 Thomas Swan 2000-07-26 11:45:24 PDT
I'm about to complete a project that's been demanding most of my time... I 
should be ready to dive head first within a week...

If anyone has an understanding of how the current mail system works, I'd 
appreciate a guiding hand at least in the beginning... 
Comment 12 Alec Flett 2000-07-26 12:07:25 PDT
There's a whole team of mail developer on the newsgroup 
netscape.public.mozilla.mail-news ready and willing to answer your questions! :)
Comment 13 David Turner 2001-01-23 08:36:50 PST
I know the last comment on this is a while ago, but I'm going to post this
anyway.

When you press the B key in PINE (you need to have this feature enabled in
Setup), you can "bounce" a message, which is what this RFE describes.  It sets
the following headers:

Resent-Message-ID: [the message ID on the message you got]
Resent-To:         [an address you enter]
Resent-Date:       [the date/time when you press "B"]
Resent-From:       [the person who did the bouncing]

Comment 14 Ben Bucksch (:BenB) 2001-01-23 14:39:04 PST
David Turner,
does it leave the other headers untouched? Especially keeping the msg-id would
be important, for threading.
Comment 15 Thomas Swan 2001-01-23 14:53:03 PST
Message-ID: is assigned a new value.  However, ReSent-Message-ID: keeps the 
Message-ID of the bounced/redirected message.  The Recieved: headers keep the 
information as if it were bounced from mail server to mail server.

The From:, Date:, Subject:, Content-Type: headers are preserverd along with the 
Reply-To:

The following headers are added after Content-Type:
Resent-Date: {Time the message was redirected/bounced}
Resent-From: {Bouncer}
Resent-Subject: {New Subject if you changed it during the bounce}
Resent-Message-ID: {Original message ID, supposedly to help or other 
bookkeeping purposes}


Added headers are as followes
Resent-Date:
Comment 16 Ben Bucksch (:BenB) 2001-01-23 15:12:03 PST
IMO, Mozilla should preserve the Message-ID. Otherwise the msg won't be threaded
correctly by the majority of mailers. It is still the same msg, just forwadrd,
similar to (automatic) forwarding email accounts.
Comment 17 David Turner 2001-01-23 15:22:38 PST
Thomas Swan: What mail client are you using?

Everything I said before applies to PINE (Outlook->PINE->NS4, for
completeness).  I just did a test with Outlook 5.0 for the Mac
(NS4->Outlook->PINE).

It added new Recieved headers as per Thomas Swann's example, and also followed
his example on the Message ID.  I'm not sure which is more correct - depends on
who you are trying to preserve threading for: the original reciever, or the new
reciever.

Comment 18 Dan Mosedale (:dmose) 2001-01-23 15:28:47 PST
It sounds like Pine is doing exactly the wrong thing regarding Resent-Message-ID
as per RFC 822 section 4.2.  We should do the right thing, which would preserve
threading.
Comment 19 Ben Bucksch (:BenB) 2001-01-23 15:31:53 PST
> depends on who you are trying to preserve threading for: the original reciever,
> or the new reciever.

Please explain. With my suggestion, will threading break for anyone?

Comment 20 David Turner 2001-01-23 16:04:43 PST
Dan Mosedale: Yes, PINE breaks RFC 822 (4.6.1, not 4.2).  

Ben Bucksch: What Outlook did (and RFC 822 requires) broke threading for the
original sender.  What PINE does appears to break threading for nobody.  My
vote, if I get one, and if it is infeasable for it to be configurable, is that
PINE is correct and Outlook is wrong.  
Comment 21 Ben Bucksch (:BenB) 2001-01-23 17:12:57 PST
As I read 4.6.1., the forwarder should just add Resent-Message-ID, leaving the
original Message-IS intact. This would be in line with my suggestion, adn I
cannot see how this would break threading for anybody.
Comment 22 Alec Flett 2001-01-23 17:14:02 PST
I have to agree. I don't think we should keep the original message ID, as it is
technically a different message.
Comment 23 Ben Bucksch (:BenB) 2001-01-23 17:28:20 PST
Alecf, the application, as defined by the reporter (tswan), is not much
different from an automatic forwarder: all mail to <info@example.com> goes to
<someguy@netscape.net> - just that here, somebody reads the mail for
<info@example.com> and decides, based on the content, if it should go to
<someguy@netscape.net> or <someotherguy@netscape.net>. In neither case, the msg
is substantially altered - it is still the same one. Even our news/mail gateways
at Mozilla.org preserve the msg-id.

I would agree, if the forwarder would edit the forwarded msg, but I wouldn't
call that "redirect" or "bounce" anymore, and thus exclude from this bug.
Comment 24 Dan Mosedale (:dmose) 2001-01-23 17:32:05 PST
David Turner: 4.2 is relevant here.  Specifically:

          Whenever the string "Resent-" begins a field name, the field
     has  the  same  semantics as a field whose name does not have the
     prefix.  However, the message is assumed to have  been  forwarded
     by  an original recipient who attached the "Resent-" field.  This
     new field is treated as being more recent  than  the  equivalent,
     original  field.   For  example, the "Resent-From", indicates the
     person that forwarded the message, whereas the "From" field indi-
     cates the original author.

as well as

     Note:  In general, the "Resent-" fields should be treated as con-
            taining  a  set  of information that is independent of the
            set of original fields.  Information for  one  set  should
            not  automatically be taken from the other.

alecf: Consider that SMTP envelope splitting by MTAs is a very similar action:
it creates a new copy of the message, adds headers (Received), and changes
transport semantics, all while retaining the same Message-ID.  However, it's
certainly true that 4.6.1 would seem to support doing as you suggest.

It would be interesting to know what the latest IETF-DRUMS son-of-RFC82x drafts
say about this stuff.  I bet they say more specifically what to do.
Comment 25 Akkana Peck 2001-01-23 17:41:39 PST
Mutt keeps the Message-id intact on bounce, but adds a Resent-Message-Id which
is new.  This seems like the right thing to do (since the message hasn't been
changed substantially from the original) but it really depends on what most
clients do (do they thread by Message-id or by Resent-Message-Id)?  Bummer that
Pine and Mutt seem to do exactly opposite things, though.
Comment 26 David Turner 2001-01-23 21:39:45 PST
Akkana: What you describe Mutt doing is what I describe PINE doing.  They
agree.  It's Outlook (and maybe RFC 822) that disagrees.

RFC 822 4.6.1 and  Alecf seem to support the Outlook method of doing things. 
But, this breaks threading (I tried it).  If you reply to a bounced message (to
the original author), your in-reply-to header will be one that he's never seen
(the bouncer created it).  

Since threading is important, and blind standards compliance isn't, I suggest
that, at least by default, Mozilla follow Pine and Mutt (rather than Outlook). 
To be fair, I can think of one possibly negative consequence: Some people may
set up filters to ignore "duplicate" messages via message id (according to:
http://www.exim.org/pipermail/exim-users/Week-of-Mon-19980727/008568.html, which
also points out why these filters are a bad idea).  In general, ignoring the
duplicate is actually correct. 

RFC 2076 agrees with Outlook and Alecf: "Resent-headers. When manually
forwarding a  message, headers referring to the forwarding, not to the original
message. Note: MIME specifies another way of resending messages, using the
"Message" Content-Type."

If there's still a strong belief in standards compliance despite the threading
thing, it could easily be a configurable.  
Comment 27 Ben Bucksch (:BenB) 2001-01-23 22:16:10 PST
What RFC 822 4.6.1 says is arguable (unless you know the intend of the author :)
). "Version" and "instance" can be understood from a user-perspective, based on
the body and important headers, not technical headers. The fact that MTAs are
allowed to add headers supports this interpretation. For me, this paragraphs
requires a new msg-ID, if the user opened a draft or a msg is forwarded with
altering the body. I cannot see a clear statement that is requires a new msg-id
for manually redirected msgs.

RFC2076 is clearer, but the question is how authorative it is.


How is the msg-ID different from, say, the date? If we have to change the
msg-id, we also have to change the Date. I could go on... Basically, this is
contrary to the whole feature and makes IMO no sense.
Comment 28 Thomas Swan 2001-01-23 22:41:55 PST
To me Redirect/Bounce should work as closely to my mail client acting as a 
.forward file to another recipient.   Also, I would assume this amount of 
activity is a wake-up call to start doing some code walking?
Comment 29 David Turner 2001-01-23 23:32:20 PST
Ben Bucksch: You also must change the date on a resend, yes.  PINE "breaks" this
one, too.  Still, I don't see how it matters what the standard says, since we
all (you, me, Thomas) agree that even if Jon Postel rose from the grave and told
us that RFC 822 means what Outlook does, it would still be the wrong thing for
Mozilla mail/news to do.  I think RFC 822 thinks of a message as "from MUA
through any number of MTAs to MUA and no further."  As this doesn't suit us, we
must abandon it. 

Thomas Swan: Yes to all of that.
Comment 30 stephend@netscape.com (gone - use stephen.donner@gmail.com instead) 2001-02-17 12:39:23 PST
*** Bug 69135 has been marked as a duplicate of this bug. ***
Comment 31 Thomas Swan 2001-04-10 12:41:45 PDT
Alright, I now have a bunch of people on the CC and have a chunk of time to
devote to adding this...  Time to knock it out...

Is there anyone on this list that can give me a hand and help me get started...
I've got the latest nightly snapshot of the source, compiled and running on Linux.
Comment 32 Håkan Waara 2001-04-10 12:47:54 PDT
Don't mark it fixed before you've got it checked in. Reopening
Comment 33 Thomas Swan 2001-04-10 12:52:21 PDT
Ack...  Didn't meant to change it to FIXED...
Comment 34 David Turner 2001-04-25 12:24:05 PDT
OK, there's a new mail RFC. Outlook is wrong, PINE and Mutt are right. The new
RFC also describes multiple bounces - they work kinda like multiple Received
headers. See section 3.6.6 of:
ftp://ftp.rfc-editor.org/in-notes/rfc2822.txt
Comment 35 Thomas Swan 2001-07-03 09:34:40 PDT
I really need to do something about this (e.g. work on it).  And, I think I have
a computer that I can do the development on.   However, I really do need some
help in getting started.  
Comment 36 Dan Mosedale (:dmose) 2001-07-11 14:43:59 PDT
Thomas: what sort of help are you looking for?
Comment 37 Ben Bucksch (:BenB) 2001-08-01 03:42:14 PDT
Thomas, if you have any concrete questions, just ask.
Comment 38 Greg K. 2001-10-06 16:23:46 PDT
*** Bug 103301 has been marked as a duplicate of this bug. ***
Comment 39 Thomas Swan 2001-10-26 17:29:10 PDT
Ok, I know have time to devote to this thing again... what areas am I going to
need to touch in order to have this.   UI, and mailnews core.  I'm pretty sure
that this won't be too involved, although I'm still trying to figure out where I
can modify the mail header before sending the message out again.

As noted above, I think this should work very similar to either the forward
(in-line) or the reply, but with not changing the reply-to and the from headers
of the original message.

I've got a linux machine and a win32 machine, I'd rather develop on the linux
box if it would be the easiest.  Suggestion?
Comment 40 Håkan Waara 2001-10-28 04:18:16 PST
As per the mozilla.org 1.0 document, we shouldn't implement new features until
post-1.0 unless they are really important.  I don't think this fits that
requirement.
Comment 41 FZiegler 2002-01-27 15:44:24 PST
The bounce part is duped in bug 109930. You may want to take a look at KDE's
Kmail which has these features. (Also Mac OS X's Mail.app: see
http://bugzilla.mozilla.org/attachment.cgi?id=66696&action=view .)

Comment 42 FZiegler 2002-01-27 21:04:48 PST
OK, I was confused earlier today when I suggested that bug 12916 and bug 109930
overlap. What Mail.app does is wrap the "bounced" message in a new one with
comments like this (described in RFC 2034, http://sunsite.dk/RFC/rfc/rfc2034.html):

> Final-Recipient: RFC822; user@isp.net
> Action: failed
> Status: 5.1.1
> Remote-MTA: DNS; postoffice.
> Diagnostic-Code: SMTP;550 5.1.1 unknown or illegal alias: user@isp.net
> Last-Attempt-Date: 2002-01-27 23:51:53 -0500

This is also what the emzlm program calls "bouncing" -- see e.g.
http://lists.nas.nasa.gov/archives/ext/linux-security-audit/2000/05/msg00132.html.

So, to me, it is in the summary of bug 12916 that the word "bounce" is
confusing. (Although, I must admit that this word does not appear in RFC 2034.)
Comment 43 Thomas Swan 2002-02-14 15:44:12 PST
Looks like I'm ready this time... Any suggestions on whether I should develop
against a nightly snapshot or the last milestone?
Comment 44 Alec Flett 2002-02-14 15:54:51 PST
these days the nightlies are quite stable.. worth developing on IMO
Comment 45 guanxi 2002-05-13 10:22:34 PDT
It seems like someone only needs to fix the "From:" line in "Edit Message As
New" (in the Message and context menus) for this to work.

I'm looking at RC2 (2002052006); I'm not sure if that was the case on the 
builds available when this was last discussed.
Comment 46 Ishq Ali 2002-06-27 09:51:06 PDT
Wow.. It seems a lot of discussion has been done on this and I just want to add
one small thing. 

The best way a spammer confirms your email address is by sending you a mail. If
it does not bounce back.. you are in his list and then you will join many other
lists. 

Can we could add a button for SPAM bounce on the tool bar (or context menu),
which bounces the message back to the sender imitating that the address was
incorrect. It would also need to add a few fake lines into the header so the
spammer does not catch you. 
Comment 47 johann.petrak@gmail.com 2002-06-27 10:11:10 PDT
regarding commend #46: note that 90% of spam email have fake sender addresses,
so this wouldnt work. 
In any case this would be a feature different from ordinary mail bounce,
so please file a new bug.
Comment 48 Steve Wardell 2002-06-27 10:20:10 PDT
Already exist: Bug 109930
Comment 49 Jo Hermans 2002-09-14 01:53:14 PDT
*** Bug 168497 has been marked as a duplicate of this bug. ***
Comment 50 Daniel Wang 2002-09-24 15:21:08 PDT
bug 109930 and bug 12916 are both ASSIGNED, yet I can't find a
difference between the two. Is this a dupe?
Comment 51 Thomas Swan 2002-09-24 15:34:10 PDT
Now, I seem to be alive with development time again.   

Regarding comment 50, yes there is a difference.   Bounce described for this bug
is an enhanced version of forwarding. 

The bounce back mentioned in bug 109930 is a auto responder or auto reply mechanism.
Comment 52 René Stach 2002-10-22 10:46:02 PDT
I would be very happy if redirection of emails would work. Bouncing is not the kind of thing I am interested in. But in my daily business work there are a lot of mails that I get which should have been addressed to somebody else. If I forward them, there is no easy way to reply to the original sender. That is very annoying. As I said: Having a possibility to redirect messages would make me very happy already.
============================


Furthermore, I would like to state here that I am quite disappointed about the development in the Mozilla mail/news client. Redirection e.g. is a very basic feature that is missing so long. And there is no progress in the development. There are lots of features in every new version of the browser module. But the mailer still looks like to Netscape 4 mailer. No real innovations, many basic features don't work reliably (autorewrap, line breaks when replying to format-flowed-messages) and obvious bugs are not fixed in years; it even seems that the mail and news component is ignored by the developers. Here some examples:

Pop-up email notification indicates wrong number of new emails
http://bugzilla.mozilla.org/show_bug.cgi?id=138631
   Apr 2002, very basic, very obvious, probably easy to fix


[FEATURE] Remember last selected message in a folder
http://bugzilla.mozilla.org/show_bug.cgi?id=10872
   Jul 1999, basic usability feature, very annoying


 From the 098 Word wrap is malfunctioning in some cases
http://bugzilla.mozilla.org/show_bug.cgi?id=124113
    Feb 2002, basic feature, obvious bug, annoying, still
    valid for 1.0.1 and also reported for 1.2 alpha


Rewrapped quoted messages gets space-stuffed
http://bugzilla.mozilla.org/show_bug.cgi?id=140884
    Apr 2002, basic feature, obvious bug, RFC violation(?)


New messages always appear at bottom even when the Inbox is sorted 
by date in descending order
http://bugzilla.mozilla.org/show_bug.cgi?id=50938
    Aug 2000, very obvious UI bug, very annoying especially in the news
    module that shows the same(?) behaviour. Your postings are never 
    sorted correctly.


Any comments? Maybe a developer or somebody fom the QA can comment on my impressions that there is no real progress in the development of the mail/news module.

René
Comment 53 louis bennett 2002-10-22 16:01:28 PDT
sorry to continue digress - i don't know about you, but handling 247 bugs in 14 days is 
nothing to complain about:

http://bugzilla.mozilla.org/buglist.cgi?short_desc_type=allwordssubstr&short_desc=&
product=MailNews&long_desc_type=allwordssubstr&long_desc=&bug_file_loc_type=
allwordssubstr&bug_file_loc=&status_whiteboard_type=allwordssubstr&
status_whiteboard=&keywords_type=allwords&keywords=&bug_status=RESOLVED&
bug_status=CLOSED&emailassigned_to1=1&emailtype1=substring&email1=&
emailassigned_to2=1&emailreporter2=1&emailqa_contact2=1&emailtype2=substring&
email2=&bugidtype=include&bug_id=&votes=&changedin=14&chfieldfrom=&chfieldto=
Now&chfieldvalue=&cmdtype=doit&order=Bug+Number&field0-0-0=noop&type0-0-0=
noop&value0-0-0=
Comment 54 Ben Bucksch (:BenB) 2002-10-22 16:12:08 PDT
> I am quite disappointed about the development in the Mozilla mail/news client.

This is so totally offtopic here. Apart from being wrong: There is a whole team
dedicated to Mailnews. Always was.
Comment 55 René Stach 2002-10-23 00:51:49 PDT
I keep watching the progress. Let's see.
Comment 56 Voyager 2002-12-08 17:14:47 PST
I'm mainly concerned about the Redirect function, but a bounce function would be
cool too.  However, as a far more useful feature, I suggest that we concentrate
on the Redirect function first; this would really be great in terms of easing
both office and home use of Mozilla.  Thanks.
Comment 57 Voyager 2002-12-09 18:35:23 PST
Hi again,
Thomas (or whoever is in charge here), you might want to look at the Mahogany
Mail open-source project found here http://mahogany.sourceforge.net/.  They
claim to have the Redirect function.  Since it is open source, I am hoping that
the legalities can be cleared with the Mahogany project with relative ease.  Thanks.
Comment 58 Garth Wallace 2002-12-09 23:55:28 PST
Spandan: legal issues are only one problem (and just because they're both open
source does not make that easy, either...not all open source licenses are
compatible). It's doubtful that Mahogony's internal architecture is anything
like Mozilla Mailnews'.
Comment 59 Jonadab the Unsightly One (Nathan Eady) 2002-12-23 13:33:53 PST
This is an important feature for situations where all headers need to be
preserved exactly intact.  Examples include reporting spam and getting tech
support.  Pegasus Mail has this feature; if you uncheck the "edit the message
before forwarding" option, it forwards in this fashion.  Headers are 
prepended (Forwarded-To:, Forwarded-By:, Forwarded-Date:, and of course
additional Received: headers and so forth documenting the path that the
message travels), but the original headers are all preserved.

"Redirect" is probably the best terminology to use for this.  "bounce" would
lead to unfortunate confusion, since normally smtp servers "bounce" messages
that are undeliverable.  "Forward" is technically correct and is what Pegasus
calls it, but users may associate that with the other two styles of forwarding
(inline or MIME).  "Redirect" should be as clear as can be to all concerned.

It is _not_ necessary to let the user edit the message before redirecting;
the whole point of redirect is to preserve the message intact.  (That can
also be done by forwarding as attachment, but many recipient mail clients
don't handle that particularly gracefully, and if the redirecting user has
nothing to add it leaves a pointless empty body.)  Users who want to edit
the message should forward it inline.  
Comment 60 Eugene Savitsky 2003-01-16 14:25:36 PST
Is this bug same as "bounce junk mail" (RFE to junk mail feature)? Or there
should be open another bug?

Tnx
Comment 61 Garth Wallace 2003-01-16 17:40:10 PST
Eugene: No. Other than having a similar name, this feature is not at all related
to forging mail server bounce messages. That's bug #109930. This bug is about
being able to forward a message to another person with the original headers
intact (rather than by encapsulating it in another messages, which is how
regular forwarding works)--this is useful in office environments, but has
nothing to do with spam fighting.
Comment 62 Jonadab the Unsightly One (Nathan Eady) 2003-01-18 11:24:43 PST
Comment 60 is a perfect example of the kind of confusion I was talking about
(in comment 59).  That's why I say that the UI should use the term "Redirect".
The term "Bounce" should be reserved for the sort of thing bug 109930 is
about, since it has been used that way as long as sendmail has existed, and 
we already have two kinds of Forward (inline (the old way) and as an 
attachment (per MIME)).  "Redirect", however, has no other meanings (related 
to email) except for what this bug is about doing, so that is the term to use.
Comment 63 Max Waterman 2003-01-29 11:22:14 PST
Re 'bounce' confusion.

Indeed, I was searching for a bug, and the term 'bounce' (IMO) is misused here,
and, as such, caused me to have to read through the whole bug to find out that
it isn't what I was wanting. I suggest removing 'bounce/' from the summary,
since the term is more commonly used in the other context (as in mail.app).

Max.
Comment 64 Jonadab the Unsightly One (Nathan Eady) 2003-01-29 18:25:48 PST
Max:  I think the term "bounce" should remain in the summary, because 
removing it would probably lead to dupes, since there is at least one
significant mail client (I forget which) that calls it that.  Also, 
reading the whole bug should not be necessary, since it is clear from 
the description of the bug, and even more clear from comment 4, that 
this is not similar to a mail-server bounce.  When I spoke of using
"redirect" instead of "bounce", I was talking about the user interface
in mail/news, not the summary in Bugzilla.  (False positives in a
Bugzilla search are better than having someone miss finding the bug
and filing a dupe.)
Comment 65 johann.petrak@gmail.com 2003-02-24 14:22:40 PST
Most linux mail clients support that feature and all of them I know call this
"bounce". So the term "bounce/redirect" in the UI would probably make things
clear to both Windoze and Linux users.
*Should* there ever be a "bounce back" function (hopefully not) it should be
called "bounce back to sender" in the UI to point out the difference.

IMO the UI for this feature should not allow any manual modifications to the
original message. So either show the standard compose window with the original
message, but nearly all of the input fields like message text, subject,
attachments etc. disabled, or just show the dialog that allows for reciepients
and identity (for resent- header info) selection.
Comment 66 Stephen Ostermiller 2003-02-24 14:30:55 PST
Maybe
"Allow redirect (bounce to new recipient) of mail messages"
would still allow the keyword bounce, but make it clear that it is not bounce back.
Comment 67 Matthias Versen [:Matti] 2003-02-24 14:39:57 PST
*** Bug 194786 has been marked as a duplicate of this bug. ***
Comment 68 Ryan Grove 2003-02-24 15:48:00 PST
This bug has been open for nearly four years due to a fundamental problem in the
way projects like Mozilla work. Namely, people like Thomas Swan and myself and
others who are not involved with the Mozilla project, but would love to
implement it, can't. Sure, we have access to the source, but the fact is that
the Mozilla source is a huge and complicated beast that is not at all friendly
to newcomers. Thus, only very, very rarely will something get implemented by a
developer who hasn't been working on Mozilla for quite some time.

I just spent a good two hours poking through the MailNews source, and all I've
come away with is a vague idea of where I *might* be able to begin implementing
this. Problem is, everything is so interrelated that I haven't got the slightest
idea whether I'm overlooking something or whether something I do might break
something else.

This is a very simple change. All that needs to happen is the same functionality
used for "Edit As New", except instead of *my* address being pasted into the
"From" header, the original sender's address should remain. Perhaps to stay
compliant with the RFC we'll need to add a new header or two. No big deal. This
is easy, easy stuff, but it's not going to get implemented until someone more
involved with MailNews either does it themselves or provides a starting point
for those of us who haven't got a clue where the change needs to be made.

There is no reason this should have been left sitting for four years, especially
with the original submitter and many others itching to implement it. This is a
five minute change. All we need is a pointer in the right direction. Anyone?
Comment 69 Ben Bucksch (:BenB) 2003-02-24 15:59:45 PST
> This is a five minute change.

No, this is far from a 5 minute change. I have worked on Mailnews before, but I
wouldn't know how to implement it without looking closly into the source
(probably more than 2 hours). Given the way Mailnews works, the problem with
features like this is usually the to pass the command and the relevant data to
the right place in the code, you might have to touch lots of files to achieve
that. It is unclear, if we can use the Edit As New datapath, it might alter the
message in unintended ways or be hooked to the UI.

> There is no reason this should have been left sitting for four years

There is: This is a (IMHO minor) new feature, and there are lots of real bugs
lying around. Something like 15000.
Comment 70 Ben Bucksch (:BenB) 2003-02-24 16:03:23 PST
strike that "minor", before somebody argues about it.

BTW: Even if it were a 5 minute change, it would still take several hours to get
it into the Mozilla tree :-(.
Comment 71 Ryan Grove 2003-02-24 16:12:09 PST
Okay, I'll grant you the benefit of the doubt with regards to how long this
modification would take, since I've never touched the Mozilla source.

This has been mentioned in previous comments, but I'll mention it again:
redirect support has, in the time since this bug was first opened, become a
standard feature of mail clients. Mozilla is one of the few major mail clients
that doesn't implement it.

As a result, while I love Mozilla Mail and want very badly to use it as my
primary mail client, the lack of this one feature is preventing me from doing
so. Like many people, I use a server-side spam filter that requires me to submit
spam by redirecting it to a special address, since the filter needs to parse the
unaltered headers and can't handle the alterations caused by forwarding. I'm
sure many other people are in the same situation.

I really think redirect functionality is comparable to the "reply to all"
functionality now found in almost every mail client. It's not necessary, but it
has become so widely used that no mail client could get by without implementing
it. This is hardly an enhacement; it's part of a standard featureset that is
missing from Mozilla Mail and hinders our capability to compete with other, more
feature-complete mail clients.
Comment 72 Ben Bucksch (:BenB) 2003-02-24 16:19:37 PST
While this might be true, it is true for 80-90% of the enhancements requests.
Not to talk about the bugs.
If I were you, I'd look into nsMsgCompose.cpp (or nsMsgSend.cpp?), if you are
willing to spend (at least) a few days on this bug. I fear I won't be able to
help you further, though.
Comment 73 Thomas Swan 2003-02-24 18:26:01 PST
Regarding comment 71 and comment 72, I know the frustration.  I had a likely
candidate working over a year ago, but had no success taking it any further
because of the size of the codebase and where some of the pieces are located.
LXR provided some relief in navigating the codebase.

Where I could use some help is identifying where and how I can
change/override/add the headers for the message object to reflect the needed
changes.  If I could find that information, I'm sure I could get something back
out pretty rapidly.

I had the UI built for it and some of the changes to bring about the appropriate
behavior at least for the interfaces and events.   When I was working on it, I
became overwhelmed and could not find where I could access and change the
headers.  I remember Seth and I had chatted once or twice, but most of the core
and/or more active developers are involved in other projects and/or bugs of more
importance that this;  hence, it has been on the back burner for some time.

My time to devote to this is random as well as I have had many other projects
and demands pull me away from this.
Comment 74 Ben Bucksch (:BenB) 2003-02-26 11:35:14 PST
Given Seth quite brief comment (in the status whiteboard), and assuming it can
in fact be an extension (not sure why such a feature should be one, because it's
as useful as forward and quite little code), you might want to look at the MDN
extension. It also messes with headers, maybe that helps you.
Comment 75 Steve Wardell 2003-02-26 20:30:20 PST
Sspitzer: What is your justification behind this being a mailnews extention and
not part of the core? While I agree that Bug 109930 should be an extension as
you marked it, why this one? I feel that it's part of a core mail program. For
any given message you should be able to Reply, Forward, or Bounce it. Do you
disagree from these are the core responses to a message (excluding deleting it,
moving its folder, etc and other management functionality)
Comment 76 johann.petrak@gmail.com 2003-02-26 22:41:47 PST
I agree with Steve - this is standard functionality in practical all Linux email
clients and - as far as I know - several Windows clients. It does not clutter
the UI, it does not require external programs, and it does not pose any
additional risks. This is simply a missing feature.
Comment 77 René Stach 2003-02-27 00:41:37 PST
To #76: This feature is not only part of most Linux clients, it's also part of
many windows clients: Opera has it, Eudora has it, the Bat! has it, the small
popcorn mail client has it. I don't know of any email client that does not have
this feature but Mozilla.

What I need this feature for? Often, I have to redirect messages to the right
person in our company. If I forward them, all replies will go back to me, if I
redirect them, the replies can go to the original sender.

René
PS: Concerning the 'bounce': To me a bounce is an error message if the mail
cannot be delivered. My suggestion would be to delete the "bounce" from the
subject if someone feels the need to change it. Why having two wods for one feature?
Comment 78 Giovanni Gigante 2003-02-27 02:30:59 PST
Actually, ages-old email clients such as "elm" have this feature since the
Beginning of Time. It is not exactly cutting edge :-)
Comment 79 Ian Leveson 2003-02-27 03:40:45 PST
I agree with comment #71: this is an essential feature both
in larger organisations and for homeworkers or anyone who 
tries to organise a networked team.

Please proceed as follows:
(1) has priority over (2)

1) get redirect working for one selected mail with an associated short-cut

2) extend redirect to work for a bunch of selected (marked) mails, where each
   will be sent individually to the same recipient, but all with just one
   command.  Maybe the short-cut could also work on one or more selected mails,
   so that there would be no need to remember two different short-cuts?

I am sorry that I have neither the time nor sufficient expertise to help with
the necessary programming.

Ian Leveson
Comment 80 guanxi 2003-02-27 07:06:56 PST
Outlook and Outlook Express, today's mail client standards, do not have this
feature (unless the very latest versions do). 

I may want the feature myself, being used to Eudora, but I can't honestly argue
that the general population expects it.
Comment 81 Steve Wardell 2003-02-27 13:21:24 PST
Pine supports bounce. Isn't Pine a better indicator of the features that should
be considered essential?
Comment 82 Thomas Swan 2003-02-27 16:27:30 PST
I just checked Pine 4.44, Pine does support this and has had it for sometime. 
Go to OTHER CMDS and there is *B*ounce.   I personally think it needs to be
labeled Redirect, but the *R* was already taken...   
Comment 83 Jonadab the Unsightly One (Nathan Eady) 2003-02-28 07:55:17 PST
The ancientness of this feature, in both Unix and Windows email clients, is
not in dispute.  People are citing Linux clients, but Windows clients also
(e.g., Pegasus Mail) have had this feature since before there was Netscape
(though the terminology "redirect" may be newer).

Regarding Outlook:  Outlook is the canonical example of a broken, inadequate
mail client that lacks important features.  Its lack of this feature can in
no way be construed as meaning that the feature is somehow unimportant.
Comment 84 Leon D. Zetekoff, NCE 2003-04-14 04:19:41 PDT
HI there...

I too need this feature....I use PMMAil 2000 (www.pmmail2000.com) for my client
and it has a bounce feature that works well...you might check with peter nielsen
over there...tell him I sent you.

I use the Mozilla client on my laptop at times and I forgot to check the "leave
mail on server" and got mail stuck in mozilla.

Also, it would be nice if I select a group of messages to forward or
"bounce/redirect" that instead of making them attachments or inline that I be
able to resend them out individually.

Thanks,

Leon Zetekoff, NCE
Blandon, PA
Comment 85 Tim Evans 2003-04-14 19:48:10 PDT
I also have a use for this feature, but I found way around it in my case.  All
our mailboxes are on an IMAP server, and I changed the premissions on all inbox
folders to give the postmaster account 'list' and 'append' priviledges.  Now I
can just drag and drop messages into the correct folder.  This solution isn't
perfect, because it bypasses the forwarding/processing rules of the SMTP server.
Comment 86 Michel Brabants 2003-04-27 14:53:02 PDT
To make this list larger :)...bouncing like in kmail would be great..it seems it
can help again spam....so, userfull...
Comment 87 Garth Wallace 2003-04-28 19:02:28 PDT
Michel Brabants: Did you even read the preceding discussion? This bug has
nothing to do with that.
Comment 88 Owen Steinert 2003-05-14 11:25:09 PDT
Let me add my "me too"! I sorely miss this feature after switching from kmail
and Eudora before that. I handle messages sent to a helpdesk, and sometimes
folks forget to address their messages properly; those messages end up clogging
my personal inbox. The redirect feature of kmail and Eudora makes short work of
those pesky misdirected e-mails. Please include this feature in future releases
if somebody has the time to work on it.
Comment 89 Owen Steinert 2003-05-14 11:28:05 PDT
Let me add my "me too"! I sorely miss this feature after switching from kmail
and Eudora before that. I handle messages sent to a helpdesk, and sometimes
folks forget to address their messages properly; those messages end up clogging
my personal inbox. The redirect feature of kmail and Eudora makes short work of
those pesky misdirected e-mails. Please include this feature in future releases
if somebody has the time to work on it.
Comment 90 Dan Mosedale (:dmose) 2003-05-25 22:39:39 PDT
Thomas: take a look at the patch in bug 61520 for an example of code that adds
headers to a message.  Also, I'm often around irc.mozilla.org in #mozmail if you
have other questions.
Comment 91 Thomas Swan 2003-05-26 15:08:20 PDT
Thank you for the pointer.  I'll and see if I can get this working again before
1.5a.  I'll try to catch you in irc over the next few days.
Comment 92 Hans-Georg Esser 2003-06-08 13:32:48 PDT
Hi,

while we're waiting for a bounce/redirect feature to appear in
Mozilla, I've written a tiny Python script that will let you do
the same job. After installing it, instead of a regular bounce,
you do a forward to "bounce@localhost" and set the Reply-To: header
to the true bounce recipient - that's it.

You can download the script from 
http://privat.hgesser.com/software/MailBounce/

Works for me, might not work for you. If so, please try fixing it, it's
truly a tiny script :)
Comment 93 Stephan Petersen 2003-07-23 05:25:13 PDT
PLEASE PLEASE PLEASE try to implement this for 1.5, this important request is
almost 4 years old, I think its time to bring this baby in!

I can't believe I have to keep Pegasus Mail on the side *just* for this one
feature...

Not implementing a bounce/redirect feature severely limits the usability of
Mozilla in certain office environments.
Comment 94 Frederik Vandaele 2003-07-23 07:39:58 PDT
Four years is a long time indeed. I suspect Thunderbird/Mozmail code doesn't allow for a redirect 
function to be built in easily, otherwise the team would certainly have added it by now, wouldn't 
they? 

*sigh* I'd try to build it myself for you, but I'm stuck with this mouse brain of mine ;-)
Comment 95 Kelly Price 2003-07-28 23:45:19 PDT
I have to add my two cents.  YES, PLEASE OH PLEASE ADD THE BOUNCE BUTTON.  
Comment 96 Luke Ross 2003-08-16 05:03:44 PDT
Created attachment 129903 [details] [diff] [review]
Patch v0.1

I present this crude patch to help speed up development. It does provide the
ability to bounce a single message to a single person. It needs a better UI,
decent error and input checking and memory freeing properly, but it works for
me and may work for people who need bounce now. It's a patch for Mozilla 1.4,
and I'm running Linux gtk2.  Anyone with a better knowledge of UIs/NSPR want to
help out? :-) (In case anyone can't find it, the Bounce option is on the
"Forward As" menu).
Comment 97 Luke Ross 2003-08-19 08:41:22 PDT
Anyone? I'd have thought at least one of nearly 70 Ccs and 80 voters would have
wanted to try out bounce functionality. It does give you Bounce/Redirect, it's
just not ready for checking into the tree. The more people try it, the more it
can be improved and the sooner it can be checked in!
Comment 98 Sam Johnston 2003-08-20 01:00:31 PDT
I would find this feature incredibly useful for:

 - forwarding SPAM unaltered
 - redirecting helpdesk requests to request-tracker unaltered

I look forward to seeing it in Mozilla and wish I had the time & moz code
experience to do it myself.
Comment 99 Ben Bucksch (:BenB) 2003-08-20 03:58:12 PDT
>  - forwarding SPAM unaltered

forward as attachment would forward unaltered. *This* feature wouldn't.
Comment 100 Henrik Gemal 2003-09-25 00:49:06 PDT
Luke, perhaps this could be done in a way so that we could package it as a XPI
file? I'm willing to help
Comment 101 Luke Ross 2003-09-25 01:19:12 PDT
I know nothing about XPI so I'm not sure I can do much on that one. I can
rewrite the patch as a mailnews extension (like Read Notification is), and if
that can be bundled as an XPI it would be good.
Comment 102 johann.petrak@gmail.com 2003-09-25 01:56:30 PDT
I disagree on this being a mailnews extension - why not include it as a proper
feature as originally requested? Especially if work is needed on the backend ...
Comment 103 Luke Ross 2003-09-25 02:32:39 PDT
'Extention' is a bit of a confusing term I think, as the mailnews extensions are
built by default (eg read notification comes in every mozilla.org build I
believe), its just keeping it under extensions means its easier to turn off if
size is critical and you're building it yourself, and it keeps the codebase
cleaner. The bounce patch could happily be an extension as it doesn't really
punch any holes in the existing API, it just adds new calls.

The XPI suggestion is just to give something that's easier to try now, I think.
I hope that when the patch is of a decent quality it can end up in the main
tree, and I've seen nothing that suggests otherwise.  I haven't bothered to tidy
up the patch yet as I'm not aware of anyone else using it.

There's been talk on this bug of someone coming up with a GUI, and as thats the
bit I'm least competent at, would they mind contributing it?
Comment 104 johann.petrak@gmail.com 2003-09-25 04:00:15 PDT
So what exactly would be needed for the GUI? If I understand this correctly, we
would need a dialog that lets you specify an arbitrary number of To: and CC:
addresses, but does not allow Reply-To:, Followup-To: or Newsgroup: addresses?
Since the email text and subject must not be changed, we can simply avoid showing
it, right? Another option that might be easier or more difficult than its own
dialog would be to show a modified version of the window that gets shown when a
"Reply" is done: the textareas would have to be read only, and only the "Send"
"Address" and "Save" buttons should be shown in that case. It would also require
the menu bar to be modified so that menu options like "spell" "quote" etc. are
either greyed out or dropped.
Comment 105 René Stach 2003-09-25 04:14:33 PDT
The light weight POP3 client popcorn behaves this way:
1. Select a message
2. Press button [redirect]
3. Message is opened in a compose window
4. I can specify a new To: and I also can edit the whole message!
5. The message is sent with the same headers (if not modified in the composing window)

Opera's mail client (version 7.20) behaves this way:
1. Select a message
2. Press button [redirect]
3. Message is opened in a compose window
4. I can specify a new To:, CC:, FROM etc. and I also can edit the whole message!
5. The message is sent with the same headers (if not modified in the composing window)
Comment 106 johann.petrak@gmail.com 2003-09-25 04:36:23 PDT
Kmail allows modification of subject and text while evolution does not.
Is there a specification of what the correct semantics of "redirect" is?
RFC822 does not seem to define this. From a logical point of view, allowing
to modify the subject or body seems to be wrong to me (though it would be more
easy to implement :) ). At least the client should
not invite the user to do such a thing similar to how it should not invite
faking the header fields (though one could do all these things and still conform
to RFC 822 ...)
Comment 107 Henrik Gemal 2003-09-25 04:40:53 PDT
Editing of the mail body should *only* be available if a pref is set. This way
we keep novice users editing the body.

Something like:
mailnews.bounce.editbody
Comment 108 Doug 2003-09-25 06:18:42 PDT
I agree that editing the body should not be the default option for this feature.
 It seems to me that if you want to add comments of your own, forwarding is the
better approach.
Comment 109 Luke Ross 2003-09-25 06:26:54 PDT
Having an editable body is very bad from a not-mauling-the-message point of
view, so I haven't implemented it or even made it particularly easy to add. If
we make it editable, then there will be no easy way to bounce a message
completely as it was (even if you _don't_ edit it).
Comment 110 Konstantin Vainer 2003-09-25 06:53:20 PDT
Having body and/or subject modified is not a good option at all.
i would vote -100 for these to be available *at all*.
the whole idea of bouncing a message is leaving a message as-is
if you want to modify it, why not just use forward option??
Comment 111 Owen Steinert 2003-09-25 07:15:07 PDT
Equate this feature to getting snail mail addressed to someone other than
yourself, you slapping on the correct address for that person, and then putting
it back in the mail, WITHOUT opening the envelope. That's all this "redirect"
feature should do. It should relabel the *unaltered* message with a new "To:"
address and change the "From: someone@somewhere.com" field to something like
"From: someone@somewhere.com (via me@here.com)". That's all it needs to do.

A "bounce" feature is something entirely different. "Bounce" would send the
message back to the sender as "undeliverable" or "refused by recipient" or
something to that effect. I don't personally care for such a feature, but the
"redirect" feature is something I would find highly useful.
Comment 112 Shi Sherebrin 2003-09-25 07:30:25 PDT
I agree with Owen.  Please let's call this "redirect" to avoid confusion.


I just verified Luke's patch (Win2k) - while I agree that appending to from the 
string " (via newsender@domain.com)" would be helpful, he does add a number of 
new "resent-from" headers.
Comment 113 Thomas Swan 2003-09-25 07:42:24 PDT
Perhaps, the ability to edit the message should be a preference.   

There is a utility to it, such as annotating something for someone and them
replying to the original sender or changing the priority of an incoming message
as you redirect it.

Luke, thank you for the patch, I'll give it a try on a linux system this weekend.

p.s. Sorry, I've been away from this way to long.
Comment 114 Luke Ross 2003-09-25 07:51:16 PDT
However if we wave the message near a compose window (for editing) then the
compose window gets to reMIMEify it as it sees fit, which I personally view as a
Bad Thing. If you want to pass a message on with annotations then surely
forward-as-attachment lets you do that?
Comment 115 Owen Steinert 2003-09-25 08:01:22 PDT
Luke has the right idea. If you want to add to or change the content of the
message, then you should be "forwarding" it as an attachment. I don't think we
can call sending a modified message to a third party a "redirect".  Simple
redirection is what this feature needs to accomplish. Forwarding as an
attachment accomplishes the annotation task and should be used for that purpose.
Comment 116 Michael S. Fischer 2003-09-25 08:22:41 PDT
Feature request: Could you please make sure this feature works with email 
messages attached as enclosures to bounce notifications, and to make sure that 
the To:, Cc: and Bcc: lists are modifiable?  

I'd like to be able to resend a message that I misaddressed without re-
composing it or forwarding it.
Comment 117 Mitch 2003-09-25 08:39:59 PDT
GUI:
As in good ol' pine, the "redirect" button or menu item should simply prompt you
for a new "To:" destination. Either mailnews's multiple-line entry box from the
Compose window, or just one line, where it's up to the user to just write a
comma-separated list of users.
Comment 118 Luke Ross 2003-09-25 08:52:23 PDT
The patch pops up a box you can key addresses into, but it means you can't pick
anyone out of your address book. Really the GUI needs to look like the top of
the compose pane, so you can enter addresses or pick from the address book, and
have autocompletion.
Comment 119 johann.petrak@gmail.com 2003-09-25 11:17:05 PDT
I wonder if it makes sense to allow CC: and Bcc: addresses too - most otehr
clients including evolution seem to support that.
Would that be fine with the backend?
Comment 120 Luke Ross 2003-09-25 11:28:41 PDT
Resent-Cc and Bcc wouldn't be a problem to add.
Comment 121 Andrés G. Aragoneses 2003-09-27 05:55:49 PDT
>Feature request: Could you please make sure this feature works with email
>messages attached as enclosures to bounce notifications, and to make sure that
>the To:, Cc: and Bcc: lists are modifiable?  
>I'd like to be able to resend a message that I misaddressed without re-
>composing it or forwarding it.

Michael S. Fischer: for that intention you have the option (already implemented
on Mozilla) "Edit as New", on the contextual menu of a message (in your case,
you should select a message in your "Sent" folder).
Comment 122 Michael S. Fischer 2003-09-27 09:36:20 PDT
knocte: Your solution depends on the user having the message in his Sent 
folder - an assumption that is not always true.  My solution is better because 
it would work whether or not the sent message was at hand.  My solution is 
also more convenient, because it's faster to re-send a bounced message in the 
context of examining a bounce notification than it is to dig through a 
potentially large Sent message folder, looking for the original.
Comment 123 Andrés G. Aragoneses 2003-09-29 03:54:37 PDT
>Your solution depends on the user having the message in his Sent folder

No, you can "Edit As New" a message that is on your Inbox folder (I mean, any
folder).

>an assumption that is not always true.

On my last comment, I said "on your Sent folder" because I was trying to apply
your needs to the solution. You said you could misaddress a message (you realize
that the address was wrong, or received a bounce notification), that's because
you had already sent the message, so I told you to look on your Sent folder.

>My solution is better because it would work whether or not the sent message
>was at hand.  My solution is also more convenient, because it's faster to
>re-send a bounced message in the context of examining a bounce notification
>than it is to dig through a potentially large Sent message folder, looking
>for the original.

Sorry but I don't think this RFE focuses to that particular solution.
Comment 124 Michael S. Fischer 2003-09-29 07:37:52 PDT
knocte: Sorry, but you're wrong.  I appreciate your help, but in order for the 
UI to work as I and many others expect it to work, fixing this bug is a 
dependency.
Comment 125 Konstantin Vainer 2003-09-29 07:58:57 PDT
> knocte: Your solution depends on the user having the message in his Sent 
> folder - an assumption that is not always true.  My solution is better because 
> it would work whether or not the sent message was at hand.  My solution is 
> also more convenient, because it's faster to re-send a bounced message in the 
> context of examining a bounce notification than it is to dig through a 
> potentially large Sent message folder, looking for the original.

Michael, maybe i am not following you, but you cannot resend a message that you
don't "have at hand" ... How do you really see this? In any case, whether you
will be using "redirect/bounce" or "edit as new" you must have found an original
message for that purpose.
Comment 126 Michael S. Fischer 2003-09-29 08:06:30 PDT
Konstantin: The message will be at hand because in many cases it will be 
attached as-is to the bounce notification.  

Try it yourself: Send a message to an invalid user, and then open the bounce 
notification.  The message will be attached.  Open the attachment.  From there 
you should be able to choose an option to re-send it (but as of now you 
cannot).
Comment 127 Luke Ross 2003-09-29 08:19:29 PDT
So really that's another bug.

In Mozilla talk, the "Edit As New" option should be enabled for messages that
are attachments of other messages, but isn't (bug 218912). "Edit As New" is
cleaner, as it would mean that the To: field is correct, whilst if you bounce it
the To: field will be wrong (as the Resent-To: field is filled in instead).

From a technical perspective, I would have thought that the fix of them would be
similar - in both cases you need to get an input stream on the correct sub parts
of the message. However I suspect it would be slightly easier to have "Edit As
New" enabled for sub-messages as if you want to permit it to be bounced you
somehow have to stop it MIME-processing the subparts.

I haven't really got the time to investigate how to open the sub-part as a
stream myself, although in a week or two I'll try to rehash the functionality of
the current patch into something cleaner and more extenstion-y.
Comment 128 Thomas Swan 2003-09-29 08:44:11 PDT
Regarding Comment 127, that is definitely another bug and not related to this one.
Comment 129 Andrés G. Aragoneses 2003-09-30 13:29:03 PDT
I agree with comment 128. I think that the RFE which Michael Fischer describes
should be opened as a new bug, called something like "Resend message from
attachment in bounce notification". I can't figure a shorter form to describe
the bug proposed.
Comment 130 Benedikt Kantus 2003-10-14 08:18:36 PDT
*** Bug 222113 has been marked as a duplicate of this bug. ***
Comment 131 Ben Bucksch (:BenB) 2003-10-24 13:51:46 PDT
> Really the GUI needs to look like the top of the compose pane, so you can
> enter addresses or pick from the address book, and have autocompletion.

This may be trivial (I havn't tried it). Look into the XUL autocomplete widget,
see <http://www.xulplanet.com/references/elemref/ref_textbox_autocomplete.html>,
"searchSessions".
Comment 132 Jo Hermans 2003-11-13 00:23:14 PST
*** Bug 225522 has been marked as a duplicate of this bug. ***
Comment 133 Stephan Petersen 2004-01-16 04:43:25 PST
4.5 years have passed since this enhancement has been suggested, Mozilla 1.6 is
about, but still no bounce/redirect :-( <sigh>. 
Comment 134 René Stach 2004-01-16 05:30:14 PST
@ #133 From Stephan Petersen: Sorry but this isn't an enhancement. It's a 
standard feature! I don't know any mail client but Mozilla/Thunderbird/Netscape 
that does not have this feature.

For those who don't understand that some people are missing this: If you are 
working in large projects or for customer care, you'll often get emails that you 
sent further to the person in charge. In those cases you can either forward the 
message or redirect it.

If you formward a message, the final recipient cannot reply to the original 
sender using the reply button. If you manually amend the email adress to reply, 
the message still says "The person who forwarded this message wrote:". It is all 
a big mess.


Thanks to all of you who tried to push this issue a little bit further.

René
PS: Does anyone of the Mozilla core team really care about this or are we 
entertaining ourselves here?
Comment 135 Luke Ross 2004-01-16 05:44:45 PST
In Mozilla lot of the new features come about because a non-core developer
sticks the effort in, either because someone wants it enough and has the skills,
or because a group of people club together and buy programmer time (eg. the
roaming profiles feature). It is increasingly common across many open source
projects for features to be included as and when patches become available, with
core developers concentrating on keeping the codebase bug-free and compiling as
that takes most of their time in itself. After all, it isn't like there's a menu
item for bounce that crashes when clicked or something.
Comment 136 R.K.Aa. 2004-01-21 22:35:54 PST
*** Bug 231777 has been marked as a duplicate of this bug. ***
Comment 137 Mark Moorcroft 2004-02-03 12:18:07 PST
Just wanted to add my voice to the throng that need "redirect" as they have come
to know it in, for example, Eudora.

--MM
Comment 138 Robert Luce 2004-02-04 12:45:12 PST
This is a very needed feature! I hate having to fire up another email client 
just to redirect a message.
Comment 139 Luke Ross 2004-02-04 13:20:27 PST
Although I'm sure the last few messages were well intentioned, we all know this
feature would be very useful; the number of votes makes it clear lots of people
want it. When bugs fill up with "me too"s, they just become unwieldy. The issue
isn't "do we need it?", but "who will code it?". I no longer have the time to do
further work on this.
Comment 140 Ron Higgins 2004-02-04 13:31:29 PST
A previous comment alluded to the possibility that placing a bounty or reward 
of monetary value on this feature request would allow it to actually get done.

What kind of $$$ are we talking about?  If everyone here chucked a buck, would 
that be enough?  Is that what it will take to get this much-requested feature 
added?
Comment 141 Luke Ross 2004-02-04 14:00:51 PST
I'm not really sure, but looking at bug 124026 I suspect it took 4000-5000$ to
get roaming profiles done. Bounce is much less complex than roaming profiles,
but I'd guesstimate you'd still need about a quarter of the time. Of course
it all depends on how well they know Mozilla and how much their time costs :-)
Comment 142 Luke Ross 2004-02-11 14:17:31 PST
Thomas: in comment 73 you say that you had prepared a UI for this. Do you still
have it? If you have some JS to handle this I may be able to graft it onto the
JS menu functions. I'd be grateful as the UI is one of the two things about this
bug I'd least like to spend time on (the other being multi-platform testing,
which besides being a really tedious way to spend my evenings is limited to
Linux and open-source Win2k compilers - hardly ideal).

mailnews team: I've been looking at pulling this out as an extension as has been
suggested. A probably-silly question, but how do you generate the binary
contract IDs? The text ones are explained on mozilla.org but the binary ones
weren't immediately obvious. Also I note that quite a fair percentage of the MDN
stuff leaks out into the general mailnews UI JS (menu items etc) - is this
considered acceptable for an extension?
Comment 143 FZiegler 2004-03-25 19:55:45 PST
*** Bug 125026 has been marked as a duplicate of this bug. ***
Comment 144 Wolfgang Rosenauer [:wolfiR] 2004-04-06 03:49:46 PDT
I've built a trunk-mozilla with the above patch and it works for me.
So I understand that only some cleanup is needed here to get it in?

Is some mailnews developer here who can look at it to get it done.
Most of the work should be done and ready.
Comment 145 Wolfgang Rosenauer [:wolfiR] 2004-04-14 04:54:43 PDT
Created attachment 146095 [details] [diff] [review]
v0.02

this patch is renewed against 1.7b and there is a small fix in JS to break the
action if more than one message is selected.
Comment 146 Wolfgang Rosenauer [:wolfiR] 2004-04-14 04:58:57 PDT
I understand that the UI is not ready because the addressbook-hook is missing.
But there is no need for a UI for CC or BCC and such things.
Bouncing is only a redirection to one other address.
But autocompletion and address-book access would be cool. But for me it's not 
as important as the base functionality. So I really would like to have it in
mozilla builds.
Comment 147 Normund Rustanovic 2004-04-14 06:57:26 PDT
in addition to the `redirect` feature request, i can also add a `mass redirect`
request. where multiple selected messages can be sent to another person as they
were received. each as a separate message. `THE BAT` mailer has this. -->

* select messages with CRTL 
* right click and select `mass redirect` for example
* a small window pops up - enter the address to which you want to send the messages
* all messages are sent sepatately - all of them are in the outbox

this would mak the `secretary` case even better - in case there are 5 emails
that need to be redirected to another person - no problem
Comment 148 Normund Rustanovic 2004-04-14 07:00:58 PDT
in addition to the `redirect` feature request, i can also add a `mass redirect`
request. where multiple selected messages can be sent to another person as they
were received. each as a separate message. `THE BAT` mailer has this. -->

* select messages with CRTL 
* right click and select `mass redirect` for example
* a small window pops up - enter the address to which you want to send the messages
* all messages are sent sepatately - all of them are in the outbox

this would mak the `secretary` case even better - in case there are 5 emails
that need to be redirected to another person - no problem
Comment 149 Normund Rustanovic 2004-04-14 07:03:33 PDT
in addition to the `redirect` feature request, i can also add a `mass redirect`
request. where multiple selected messages can be sent to another person as they
were received. each as a separate message. `THE BAT` mailer has this. -->

* select messages with CRTL 
* right click and select `mass redirect` for example
* a small window pops up - enter the address to which you want to send the messages
* all messages are sent sepatately - all of them are in the outbox

this would mak the `secretary` case even better - in case there are 5 emails
that need to be redirected to another person - no problem
Comment 150 Kelly Price 2004-04-14 10:25:50 PDT
I belive the "don't bounce more than one email" limitation is a bug onto itself,
because I tend to bounce four or five emails on my own system per week to other
computers in my network.

However, we should limit how many addresses those bounces go to.
Comment 151 Mark Bitterling 2004-04-14 11:17:48 PDT
Why should we limit how many addresses those bounces go to?  

That makes no sense to me.  I ought to be able to redirect the email to as many people as it should go 
to.  The software should not implement some artificial limitation.

Comment 152 Wolfgang Rosenauer [:wolfiR] 2004-04-14 11:30:57 PDT
OK, it's all a problem of manpower. The limit that only one message can be
bounced at a time was in the first patch also but the UI didn't catch it correctly.
I agree that there should be no limit in the recipient list but CC or BCC
doesn't make sense, do it? I know of pine and mutt on Linux and both do only
bounce to "normal" recipients.
In fact I didn't add a limit but catch the limit correctly.
If I have time and know how to do, I will check if it is possible to bounce more
than one message to a list of recipients. But note, that I'm not able to do the
UI thing.
Comment 153 Luke Ross 2004-04-14 11:43:50 PDT
It's trivial to make it bounce more than one message. Just edit the JavaScript
in mailWindowOverlay.js. 

Remove where it says 'if (messageArray.length != 1) alert("Only one message at a
time can be bounced."); else {' and then replace 'BounceMessage(loadedFolder,
messageArray, recips);}' with something like 'for (var i = 0; i <
messageArray.length; ++i) { var a = new Array(1); a[0] = messageArray[i];
BounceMessage(loadedFolder, a, recips); }'

I doubt this patch will get anywhere near Mozilla until it has a proper
addressbook UI. That's probably the major stalling point.
Comment 154 Kelly Price 2004-04-14 15:09:42 PDT
Back in 1998, University of Maryland at College Park's email servers were
brought down when someone left an account open on a lab computer, and another
person adjusted the .forward to spam everyone.

Two days later, it happened again.

Immedately afterwards, the admins slapped in a "It won't work if you go over X
people" limit.

I was a tech aid with the college's computer services office, and was in the
college newspaper's offices in the latter "Attack".  Lets just say they got
first hand knowledge of the problem. :)

I do say, limiting bouncing to X amount of addresses may cut down on some
inadvertant spamming.  Of course, if a person's that brave/ignorant/etc, it
shouldn't be hard coded (aka adjustable via hidden pref).
Comment 155 Henrik Skupin (:whimboo) 2004-04-20 04:27:17 PDT
*** Bug 240976 has been marked as a duplicate of this bug. ***
Comment 156 David :Bienvenu 2004-04-20 07:28:45 PDT
I'm not sure I'm crazy about implementing this in the compose service - the
compose service is a singleton, for one thing, a service, so it shouldn't have
state like this. If you get multiple simultaneous calls to the bounce method,
all hell will break loose. It needs to move somewhere else. I'll think about it
a little - I suspect it could simply be implemented in js.

Re picking addresses, we have an address picker - why can't that be used? If
you're in the compose window, and click the Address button, a window comes up
that allows you to pick addresses. Seems to me that same widget could be used
for this...
Comment 157 Luke Ross 2004-04-20 07:39:37 PDT
As has been commented before, this really should be a mailnews extension, and
making it an extension shouldn't be too difficult. I just put it in there
initially because that's where I found the forwarding code :-) I did start
picking apart a copy of the mdn mailnews extension as the starting point of a
bounce one. 

Can JS both open the stream of the raw IMAP message and also use the SMTP send
service? If so it could be JS only and everything gets a lot easier.

I was sort of hoping someone could have a look round and find the appropriate
address book chooser to use and come up with some JS to call it.

I still don't really have the time (or the knowledge) to finish this.
Comment 158 Wolfgang Rosenauer [:wolfiR] 2004-04-20 08:08:38 PDT
IMHO this shouldn't be an extension. Bounce functionality is a rfc base 
functionality. Otherwise we could move the forwarding functions to extensions as
well.
Comment 159 David :Bienvenu 2004-04-20 08:39:22 PDT
js can definitely stream the message and use the smtp service. And if there's
something preventing this from working from js, then we can fix it.

abSelectAddressesDialog.xul is what I was referring to. Here's a usage example.

http://lxr.mozilla.org/seamonkey/source/mail/components/compose/content/MsgComposeCommands.js#1941
Comment 160 Luke Ross 2004-04-20 08:58:53 PDT
Cheers, I'll see if I can do a 100% JS version tonight.
Comment 161 Luke Ross 2004-04-29 08:06:47 PDT
Hmmm nsMsgCreateTempFileSpec is a C++-only call; it's not part of the public
interface for nsMsgCompUtils :-(
Comment 162 David :Bienvenu 2004-04-29 09:04:28 PDT
you can write its equivalent in js, I believe. You can create a file spec and
then set the path...you could create an nsILocalFile to create the path.
Something like this...there's probably an easier way to do this. And eventually,
we'll be getting rid of nsFileSpec and replacing it with nsIFile...

something like this:

var dirServiceClass =  Components.classes["@mozilla.org/file/directory_service;1"]
var dirService = dirServiceClass.getService(Components.interfaces.nsIProperties)

var tmpDir = dirService.get("TmpD", Components.interfaces.nsIFile)

        var filespec =
Components.classes["@mozilla.org/filespec;1"].createInstance(Components.interfaces.nsIFileSpec);

filespec.nativePath = tmpDir.path;
filespec.leafname = "nsmail.tmp"
filespec.makeUnique()
Comment 163 Scott MacGregor 2004-06-04 00:20:14 PDT
*** Bug 245492 has been marked as a duplicate of this bug. ***
Comment 164 Scott MacGregor 2004-06-04 00:22:15 PDT
*** Bug 230928 has been marked as a duplicate of this bug. ***
Comment 165 Scott MacGregor 2004-06-04 00:33:55 PDT
*** Bug 242311 has been marked as a duplicate of this bug. ***
Comment 166 Scott MacGregor 2004-06-04 00:37:27 PDT
*** Bug 236859 has been marked as a duplicate of this bug. ***
Comment 167 Eyal Rozenberg 2004-06-25 08:42:25 PDT
Regarding patch v0.02 - it seems to me what's necessary is a generalization of
the forwarding code rather than a seemingly separate implementation of. Now, the
following:

prompt("Please enter a recipient to bounce the message to.");

is quite a bad idea as David has mentioned above. But instead of using the
widget from the compose window - why should Bounce not use
_the_actual_compose_window_, just like Forward does? As though the user had done
an 'Edit as New', only with the 'From' rubrique grayed-out, a 'Forwarded From'
rubrique similiar to the 'From' rubrique added to the compose window, and the
address picker as usual. The message composition could be made read-only. Or not
(maybe people would like being able to bounce edited version of messages). Just
think of the oh-so-sweet consistency this would maintain.
Comment 168 Kelly Price 2004-06-25 09:58:28 PDT
I think using the actual window is equally as bad as just the prompt itself. 
Not only would you have to disable most of the widgets itself, but folks may
confuse it as to being a forward window.  BOUNCE DOES NOT MEAN EDIT!  Pine
doesn't have a "Edit and bounce" feature.  It never had it!

Creating a "Bounce to" window would be best.
Comment 169 Anne Judge 2004-06-25 10:37:30 PDT
(In reply to comment #168)
>   BOUNCE DOES NOT MEAN EDIT! 

In this case, it becomes mostly useless to me, and I should remove my vote.  I
require a redirect feature that allows me to add a passphrase at the top of a
message for approval to an email list; also (but less important) when mailing
list messages are rejected for being too large and bounced to me as
administrator or moderator of the list, I often strip attachments, put them on
the web site, and add a link to them in the body of the message (with a note
identifying this as a list administrator action) - but I need the original
sender to stay the same.  There are legitimate reasons for editing redirects!!!

Anne
Comment 170 Jonadab the Unsightly One (Nathan Eady) 2004-06-25 11:46:41 PDT
> >   BOUNCE DOES NOT MEAN EDIT! 
> In this case, it becomes mostly useless to me, and I should remove my vote.

Yes, you should.  The existing inline forward feature already covers the 
case where you want to edit.  A redirect is specifically for the case where 
you want to send the message along exactly as it stands.
Comment 171 David Turner 2004-06-25 12:04:44 PDT
(In reply to comment #170)
> > >   BOUNCE DOES NOT MEAN EDIT! 
> > In this case, it becomes mostly useless to me, and I should remove my vote.
> 
> Yes, you should.  The existing inline forward feature already covers the 
> case where you want to edit.  A redirect is specifically for the case where 
> you want to send the message along exactly as it stands.

Recall that redirect retains the From: headers, while forwarding doesn't.  So,
there's a good reason to redirect rather than inline forward.  There is no good
reason to disallow editing, since it's a feature that people will actually use.
 If you think that editing is generally a bad idea, you can always require an
additional click to enable it.
Comment 172 Steve Wardell 2004-06-25 12:09:52 PDT
My thinking is that editing of bounced email should not be allowed at all. The
reasoning behind it is this. Bounced emails are seen by many folks as having a
clear, sealed envelope sent on to them. The content is assumed to be unedited
from it's original state. Allowing a user to edit the data before a bounce can
create misinformation about what was really said by the original sender of the
bounced message.
Comment 173 Shi Sherebrin 2004-06-25 12:29:40 PDT
again, *please* drop "bounce" from the lexicon of this bug - "redirect" carries
all of the meaning and none of the potential confusion.
Comment 174 Anne Judge 2004-06-25 12:33:52 PDT
Well, there's Apple's Mail solution, where "(Modified by [name])" is added to
the subject line of a modified redirected message.

For the reason mentioned (modified "from"), forward does not do what I need.  I
can NOT use that to moderate my mailing lists.  I MUST use redirect, as offered
by Mail or Eudora.


Anne
Comment 175 Jonadab the Unsightly One (Nathan Eady) 2004-06-25 13:21:45 PDT
> For the reason mentioned (modified "from"), forward does not do what I need.
> I can NOT use that to moderate my mailing lists.  

If you're not modifying the From: field, then you shouldn't be modifying the
body either.  Ever.  Approval for moderated lists or newsgroups is normally 
done by adding an approval header, but I would consider any modification of 
the body to be wrong (at best a misrepresentation, very likely fraud, and
possibly even identity theft) if the From header is not also modified to
indicate the author of the revised message.  I understand that's not your
intention, but for moderation you really should be using a header, not
making changes to the body.  That is the normal way of doing it.  And yes,
I know that people who want to forge headers and misrepresent what other
people said will find ways to do so, but I don't think Mozilla should be
going out of its way to make this an easier thing to do.

Adding a header (for approval, or to indicate who forwarded the message, or
cetera) is acceptable, since a header is metainformation.  Mail servers add
headers automatically all the time (and in fact would be remiss if they did
not do so.)
Comment 176 Vladislav Duma 2004-06-25 13:38:54 PDT
(In reply to comment #175)
> If you're not modifying the From: field, then you shouldn't be modifying the
> body either.  Ever.
It's the user who choses how to use the application, not application itself!
Please do not introduce unneccessary limitations.
> ... I would consider any modification of 
> the body to be wrong (at best a misrepresentation, very likely fraud, and
> possibly even identity theft) if the From header is not also modified to
> indicate the author of the revised message.
Do you really consider email FROM header as something truthworthy? So funny!
One can freely adjust the mail account settings to any arbitrary name and FROM
address in 2 minutes. Prohibiting to change the message body affects only
usability, not possibility.
> I know that people who want to forge headers and misrepresent what other
> people said will find ways to do so, but I don't think Mozilla should be
> going out of its way to make this an easier thing to do.
This is kind of security through obscurity. Changing the FROM field is so easy!
If people will see the possibility to edit message without changing FROM
address, they possibly would realise that the letter from bill@microsoft.com
could have been actually sent by random@user.com
Comment 177 Marcus Augustus Alzona 2004-06-25 18:58:20 PDT
I agree with Steve's Comment #172:
> My thinking is that editing of bounced email should not be allowed at all. The
> reasoning behind it is this. Bounced emails are seen by many folks as having a
> clear, sealed envelope sent on to them. The content is assumed to be unedited
> from it's original state. Allowing a user to edit the data before a bounce can
> create misinformation about what was really said by the original sender of the
> bounced message.

A "redirect" should be the original message, as it was originally sent, from the
final viewer's perspective.  If you want to modify things along the way, great -
then it isn't a redirect, its a forward, and you should claim credit for it with
new From and Date fields.

Comment #174:
> Well, there's Apple's Mail solution, where "(Modified by [name])" is added to
> the subject line of a modified redirected message.

That sounds better - if you modify the message, then it modifies the subject line.

> For the reason mentioned (modified "from"), forward does not do what I need.
> I can NOT use that to moderate my mailing lists.  I MUST use redirect, as
> offered by Mail or Eudora.

Perhaps its just me, but I don't think that the central thrust of this feature
was to help people moderate their mailing lists.  I've always seen it as a
end-user (non-admin) function for people to redirect messages to others without
editing the body.

I trust you when you describe what you need in such a feature, however I don't
think its worth breaking the "bounce/redirect" paradigm for it in Mozilla.  If
you "MUST use redirect, as offered by Mail or Eudora" then I'd prefer that you
do indeed keep using redirect as offered by Mail or Eudora.


(In reply to comment #176)
> It's the user who choses how to use the application, not application itself!
> Please do not introduce unneccessary limitations.

Well, on one level I agree with you.  But, where do you stop?  I mean, if you
think that way, would you want the "From" and "Date" fields to be always
modifiable in every message?  And if not, why not?  I mean, isn't that an
"unnecessary limitation"?

Perhaps the difference between "necessary" and "unnecessary" is if it breaks the
expected end-user experience.  Significantly increasing the ability to have
false/incorrect/misleading "From" and "Date" headers in an outgoing message
probably counts as breaking the expected end-user experience - and therefore we
have a "necessary limitation" on "From" and "Date".  Making it very easy to
modify the body content of a message while retaining all the same headers (From,
Date) that a typical end-user sees/uses for identifying the source of the
message would count as breaking the end-user experience as well (IMHO) - and
therefore we should have the "necessary limitation" on modifying the body of a
redirected message.

> Do you really consider email FROM header as something truthworthy? So funny!
> One can freely adjust the mail account settings to any arbitrary name and FROM
> address in 2 minutes. Prohibiting to change the message body affects only
> usability, not possibility.

I'm sure he doesn't consider it trustworthy any more than you or I do.  You're
missing the point - he's not saying that you *can't* modify the body field
without adding new From/Date fields...its that you *shouldn't*.  And what the
"proper" behavior for a given action is what Mozilla tries to implement when
adding features.


> This is kind of security through obscurity. Changing the FROM field is so
> easy!

Again, we all know this already.

> If people will see the possibility to edit message without changing FROM
> address, they possibly would realise that the letter from bill@microsoft.com
> could have been actually sent by random@user.com

So, if I understand you correctly, you're advocating that we should put this
feature in so that many more people would realize that you can modify messages
and have them appear to the end user (unless they're displaying the
"Resent-From" fields)?  In other words, since we know the global email system is
broken in some ways, let's just break it a bit more?  Are you serious?


Jonadab's Comment #175 lays out a pretty good solution to Anne's primary need:
> Adding a header (for approval, or to indicate who forwarded the message, or
> cetera) is acceptable, since a header is metainformation.  Mail servers add
> headers automatically all the time (and in fact would be remiss if they did
> not do so.)

Based on Eyal's Comment #167 - which is brilliant.  I agree - "oh-so-sweet
consistency:.  :-)

Comment 178 Kelly Price 2004-06-25 21:14:27 PDT
Well, folks are expressing the security concerns with allowing folks to edit a
bounce.  Very much the traditional way was to send it whole to another email
address, as-is.  Pine does it that way.  I'm not sure if there's an IETF RFC
which says it has to be that way.  Anyone know if RFC 2822 covers this?

And yes, I'm using "bounce" which implies a user action instead of "redirect"
which implies a filter action (which I also would like, BTW, but that's another
bug).

Comment 179 Vladislav Duma 2004-06-26 01:17:30 PDT
Comment 177:
> > It's the user who choses how to use the application, not application itself!
> > Please do not introduce unneccessary limitations.
> 
> Well, on one level I agree with you.  But, where do you stop?  I mean, if you
> think that way, would you want the "From" and "Date" fields to be always
> modifiable in every message?

They are, actually! One can create multiple mail accounts in the same Mozilla
profile with different email addresses and names and choose the arbitrary
identity when sending the mail even with the current Mozilla.

Mozilla still does *not* check that name is actually the same throughout the
profile. Neither checks it that the sender's name is the same as the one stored
in the system registry (on Windows) or in /etc/passwd (on *nix). ;-)

And the typical OS does not disallow changing the system date (which is used for
outgoing mail). Mozilla doesn't track /suspicious/ date/time changes.

> Perhaps the difference between "necessary" and "unnecessary" is if it
> breaks the expected end-user experience.

... and seeing no possibility to edit the message gives the false expierence
that this could not be done.

> I'm sure he doesn't consider it trustworthy any more than you or I do.  You're
> missing the point - he's not saying that you *can't* modify the body field
> without adding new From/Date fields...its that you *shouldn't*.

What does this mean - shouldn't? Sending email is not a binding treaty.

For the morally "legitimate" usage see the initial bug report.

> In other words, since we know the global email system is broken in some
> ways, let's just break it a bit more?  Are you serious?

Indeed, here I see two aspects.

First, I do not propose something hacking of the system or abusing it: the
possibility is already in the system, can be (and is) used by people, so the
only issue is the interface.

Second, the system is not actually broken: the rule that the user-information is
sent by the sender's software and no checks are performned clearly means that
this information is completely under sender's control. This is the feature of
the (current) email system, which I personally appreciate very much (looking
from the position of abstract freedom).

The solution on the bug I would prefer is adding a string like "(forwarded by
...)" to the Subject. (Of course the subject must remain editable!)
Comment 180 Marcus Augustus Alzona 2004-06-26 10:54:38 PDT
Vlad from Comment #179
> They are, actually! One can create multiple mail accounts in the same Mozilla
> profile with different email addresses and names and choose the arbitrary
> identity when sending the mail even with the current Mozilla.

Yes, we know this already.  We knew it in Comment #176 as well.  I would expect
that many or most of the people here have even gone to the level of telnetting
to port 25 and writing a message raw at some point.

> And the typical OS does not disallow changing the system date (which is used
> for outgoing mail). Mozilla doesn't track /suspicious/ date/time changes.

Yes, Mozilla does the right thing and uses the system date.  Thanks for stating
the obvious yet again.

It is interesting that you seem to think that your description of how to change
the From and Date of any given message somehow supports your case.  Indeed, my
take on it is the opposite - you've shown how one of Mozilla's central
activities, sending a new message, does not make it easy to change the outgoing
From and Date in its *design*.  Yes, as we all know, you can create bogus mail
profiles to change the From address - however, the support of profiles isn't
*designed* to support changing your From address to whatever you want on the
fly, it is instead intended to support the use of multiple mail accounts.

In this case, we're talking about putting the modification of the From/Date in
the *design* of the redirect functionality.  There's a difference.


>> Perhaps the difference between "necessary" and "unnecessary" is if it
>> breaks the expected end-user experience.
>
> ... and seeing no possibility to edit the message gives the false expierence
> that this could not be done.

Yes!  And certainly, we all know how crucial the "Mozilla Email ReDirect"
functionality is to educating people around the world about spoofed headers. 
That being not crucial in the least bit.

>> I'm sure he doesn't consider it trustworthy any more than you or I do. You're
>> missing the point - he's not saying that you *can't* modify the body field
>> without adding new From/Date fields...its that you *shouldn't*.
>
> What does this mean - shouldn't? Sending email is not a binding treaty.

Shouldn't means "should not".  As in, the point many people are making here is
that while any given email application *could* modify the body (the data) of the
message, it *should not* do so in our opinion - the only changes should just be
additions the headers (the meta-data).

Also, I'm in agreement with you - "sending email is not a binding treaty". 
Along those lines, I would add that "sending email is not swimming" and "sending
email is not a chocolate cupcake".  (Wait, wasn't this a Saturday Night Live
skit?  Yeah, it was:

<a
href="http://www.rangelmd.com/2003/01/update-mcdonalds-made-me-fat-lawsuit.html">SNL
Big N Tasty</a>

So, yes, its not a binding treaty per se.  Unless, of course, two countries
exchange the text of a treaty back and forth over email, in which case it may
very well be a binding treaty.

And before you go off ad nauseam on how you can fake email, how it is not
secure, etc., just remember - you can fake many things in the non-electronic
world as well.  Signatures, contracts, money...whatever.  That it is possible to
have forgeries doesn't preclude any given communication/documentation method
from being a legal document.  Note that I'm not making claims on how wise(or
secure or valid) it is to use a particular medium - I'm just saying that we (as
in, overall technical people associated with Mozilla in some way (at least, in
that we're reading this bug #12916)) would be mistaken to think that legal(ly
binding) documents aren't sent all the time right now (for better or worse) via
email.


> For the morally "legitimate" usage see the initial bug report.

No, I believe you're wrong about this.  A five year old initial message doesn't
give absolute determination on the focus and scope of this issue/feature. 
Instead, it is a starting point.  As are all of the other bug reports that were
made about "bounce/redirect" and were marked as duplicates (do a search on this
page for "has been marked as a duplicate of this bug").

Indeed, we are (in part) debating the "legitimate" usage of the redirect
function right at this very moment.

> First, I do not propose something hacking of the system or abusing it: the
> possibility is already in the system, can be (and is) used by people, so the
> only issue is the interface.

Yes, the issue is the interface.  Specifically, what the Mozilla
developers/community/whatever as a whole believes is legitimate in terms of
functionality offered in the Mozilla user interface.  In fact, at some macro
level, Mozilla in many ways is just a user interface to SMTP, IMAP, POP, etc.

> Second, the system is not actually broken: the rule that the user-information is
> sent by the sender's software and no checks are performned clearly means that
> this information is completely under sender's control. This is the feature of
> the (current) email system, which I personally appreciate very much (looking
> from the position of abstract freedom).

Rule?  What rule?  Again, it seems that you're trying to claim that Mozilla
should do something simply because it can.  You are correct in saying that, as
the "sender's software", Mozilla sends the user information - but you're making
the wrong leap from the "sender's software" to the "sender".  Indeed, Mozilla
(the "sender's software") *could* do many things:

- Add new meta-data(i.e. Headers) to the top of the message, perhaps
  "Resent-From:" and "Resent-To:" headers, while keeping the original
  headers (including Date and From) and original body the same
- Modify the Date and From
- Modify the Body
- Add attachments, sending them with the new message
- Add a big Mozilla logo, and link to http://www.mozilla.org
- Send a copy of the message to the redirecting user's email address
- Send a copy of the message to the original user's email address
- Send a copy of the message to alt.stupid.mozilla.tricks
- Send a copy of the message to the government
- Send a Treaty to the U.N.

...however, it *shouldn't* do most of these things.  Just because the sender's
software can do all these things for the sender, doesn't mean it should do all
these things for the sender.  For instance, I don't think we need to include
Treaty sending in Mozilla.  I know, I know, perhaps that (as you've pointed out)
"gives the false expierence that this could not be done." - but, that's just the
type of sacrifice (leaving out a "Treaty Sending" option for the user) I'm
willing to make.

As far as abstract freedom, whenever I need to do that,
"telnet smtp.server.name 25".  Type away.


> The solution on the bug I would prefer is adding a string like "(forwarded by
> ...)" to the Subject. (Of course the subject must remain editable!)

If it isn't obvious by now, that solution (to me) would be wrong.

The solution I'd like to see would be as follows:

- On a UI level, open up the same send/forward message window, except somehow
tagged "Redirect" and without the possibility to add/edit anything except the
"Redirect-To:" fields (replacing the normal "To:/CC:/BCC:" options) and the
"Redirect-From:" field (the normal "From:" picklist of configured accounts).

- On a protocol level, it would take the original message (with all of the
headers intact), add "Redirect-To:" "Redirect-Date:" and "Redirect-From:"
headers to the top, then hand it off to the outgoing SMTP server - which would
then append the normal in-transit mailserver meta-data to the top of the message
(ie. Received: from..etc.).
Comment 181 Vladislav Duma 2004-06-26 11:14:29 PDT
(In reply to comment #180)

It's obvious that we have different opinions on what kind of software Mozilla
would be if it were within our powers: a high-level system that implements
secure/trustworthy message exchange (your opinion), or a swiss-army application,
that implements a handy interface to "telnet smtp 25" (my opinion).

Further details seem to be not so interesting for others. Perhaps we can
continue flaming by email?
Comment 182 Marcus Augustus Alzona 2004-06-26 12:49:50 PDT
I'd agree that its obvious that we have different opinions, but I would disagree
with your characterization of my opinion.  I have no illusions that disallowing
editing makes anything truly secure/trustworthy (hence my comments on how we
already know how to spoof mail, dates, etc).  However, I do think your
"swiss-army" characterization of your opinion is right on the mark, which
highlights the differences.

The availability of such a swiss-army application would be great - I know I'd
probably use it at least some, and I can see why you prefer it as well. 
However, the core question is if Mozilla is supposed to be this type of
application.  I would submit that it is not.

That all being said, I agree, I think we have laid out our positions by this point.
Comment 183 Bartosz Wucke 2004-06-26 13:55:09 PDT
Maybe instead of arguing what extra functionality to add to this feature (over
next 3-4 major releases), we'd better push it through in its simplest and most
desired by most voters form (redirect without editing) ASAP and then either file
another bug for the extended functionality or write an optional extension that
does all the swiss army style stuff and get the most basic thing done?

I'd personally very gladly welcome an extra menu item "advanced edit" which
would allow me to add/remove/edit any header or any part of any email and then
save or send it like that, but it's not what I'd squeeze under the
"bounce/redirect" bug. 
Comment 184 Shi Sherebrin 2004-06-26 21:38:22 PDT
(In reply to comment #178)

> And yes, I'm using "bounce" which implies a user action instead of "redirect"
> which implies a filter action (which I also would like, BTW, but that's another
> bug).

Kelly, I feel differently aobut the implications of 'bounce' vs. 'redirect' in
terms of user actions - if I send an email to someone and their server rejects
it (e.g. their mailbox is full), I say that it 'bounced' - the *server*, not the
user, did that.  Also, I don't read an exclusively non-user action from the word
'redirect'.

However, maybe the disagreement we have indicates a need to think some more
about other possibilities for the nomenclature of this feature?  A one-word
solution is nice (personally, I'd still vote for 'redirect'), but what about
something like "forward original" or "forward unedited"?  After all, this is
probably best presented to the average user as a variation on forwarding.

In terms of Anne's needs, perhaps the default could be that editing is disabled,
and a menu options somewhere could be used to enable editing (with the
accompanying addition of an "Edited by:" header), or perhaps a different version
of forwarding could be added later as was also suggested, "forward original and
edit" which would have the "Edited by:" header and maybe also a "modified by"
appended to the subject, which Anne could easily remove if she wants.

Shi.
Comment 185 Yann 'Ze' Richard 2004-06-27 10:55:33 PDT
any one have compiled thunderbird with the patch 0.02 and have binary for 386 or
have made debian package ?
Comment 186 Warren Ernst 2004-07-22 16:32:16 PDT
It is almost impossible to comprehend that a bit of *basic* and long-standing
email client functionality like Redirect (or Bounce) is *still* not here after
FIVE YEARS of talking about it.

Now that Thunderbird takes plugins for this sort of thing, I'm starting to think
it is completely impossible.
Comment 187 Pawel Krzesniak 2004-07-30 02:25:56 PDT
Created attachment 154746 [details]
Bounce extension 0.0.3

it's REALLY development phase code. Only people who wants to help me with
development should download and install.
Comment 188 gekacheka 2004-07-31 11:44:35 PDT
(In reply to comment #184)
> (personally, I'd still vote for 'redirect'), but what about
> something like "forward original" or "forward unedited"?  After all, this is
> probably best presented to the average user as a variation on forwarding.

Redirect is very different from forwarding, so if it is implememented,
its name and its UI should be kept separate.  
  When you forward a message, the "From" header is set to your address, 
    so when the recipient replies, the reply is addressed to *you*.  
  When you redirect a message, the "From" header remains the original
    "From" address, so when the recipient replies, the reply is
    addressed to the *original sender*.  
When people do not understand this distinction, it can cause serious
problems for others.

As one list author explains:
<quote> 
  Why do you insist that RRE subscribers not use the Eudora
  "redirect" command to pass messages along to others?

    The Eudora "redirect" command causes me endless headaches, and I
    do indeed insist that RRE subscribers not redirect my
    messages. Here is what happens. You redirect an RRE message to
    person X. Person X then wants to reply to you, thanking you for
    passing the message along. Their reply, however, goes to me, not
    you, and I have to respond and explain what the problem is. This
    happens all the time, and it is a major nuisance.

    It is true that, by using "redirect", you are protecting yourself
    against the risk of misdirected replies -- that is, replies that
    were intended for me. At the same time, however, you are also
    exposing me to the symmetric version of the same risk -- the risk
    that I will get replies that were intended for you. That is why I
    often say that "redirect" is literally immoral. Many
    non-Eudora-users do not understand the "From: ... (by way of ...)"
    header fields that "redirect" creates, and experience shows that
    no amount of explaining will suffice to get the concept across to
    them. Indeed, many Eudora users themselves do not understand these
    From: fields; they use "redirect" because they think it's just
    like "forward" but without those unsightly ">" intendations.

    And that's not all. When people redirect RRE messages to other
    mailing lists, I frequently get messages saying, "who are you and
    why are you posting to our mailing list?". I don't like having to
    respond to these messages, explaining that I had never heard of
    their mailing list and never sent anything to it, when as far as
    they can tell they have incontrovertible proof to the contrary
    sitting right in front of them. I also frequently get error
    messages that are automatically generated when someone redirects a
    message of mine to a mailing list that includes some bad
    addresses.

    I have taken these issues up with Qualcomm, which markets
    Eudora. They were completely unresponsive. Their approach was that
    it was unthinkable that any functionality should be removed from a
    program, and they asserted that any misuse of the command was the
    fault of its users. I disagree. Putting the "redirect" command
    where beginners can find it is like leaving a loaded handgun lying
    around, disguised as a coffee mug. It's bad design. "Redirect"
    should be understood as a type of forgery.
               (from http://polaris.gseis.ucla.edu/pagre/rre-faq.html)
</quote>  

The need for redirect in the instances I've heard would be 
reduced if Mozilla allowed the recipient reply to a forwarded attachment
message.  Currently Moz1.8a2 lets you open the attached message, but in the
opened view the reply buttons are disabled.  (Anyone know why?)

If redirect is implemented, the default UI should be designed so it is
significantly easier to do a 'forward-attachment' than to do a 'redirect', so
people will not use 'redirect' when a 'forward-attachment' would do. 
(Customization may allow people who know they really want a 'redirect' to change
this.)

If redirect is implemented, there could be some safeguards against mistakes like
above.  One idea is a whitelist of email addresses which can be redirected.  The
whitelist would be initialized with the user's email account address(es).  The
idea is to allow the user to redirect messages addressed personally to the
user's account(s), but not messages directed to a mailing list (at least not
without the user doing some extra work to add it to the whitelist).


Comment 189 gekacheka 2004-07-31 13:06:01 PDT
Enabling reply from a forward-attached message is in bug 204350
Comment 190 Garth Wallace 2004-07-31 19:53:13 PDT
I agree with the whiteboard. This should be an extension, so people who need it
(mostly secretaries, administrative assistants, and the like) can have it
installed and the rest of the population who have no real valid use for it won't
be confused by it.
Comment 191 Pawel Krzesniak 2004-08-04 03:35:46 PDT
(In reply to comment #187)
> it's REALLY development phase code. Only people who wants to help me with
> development should download and install.

hi everybody,

few days ago, I've created an attachement to the bug -- it is extension to
thunderbird, which allows to bounce emails. (bouncing like mutt or pine does).

There was almost no responses to my post (exception is Warren Ernst -- thanks). 
And my question is: are you going to deliberate next 5 years on redirect/bounce
dis- and advantages or maybe somebody wants to help me in extension development?

"Core part" of bouncing mechanism works -- you can bounce messages. But I need
help in work on the code - it's not perfect. I'm asking you to help me. 
Take a look in bounce.xpi:/BUGS file and try to write some patches. With no help
this code will die.

thanks,
-- 
Pawel
Comment 192 Shi Sherebrin 2004-08-04 05:45:39 PDT
Dear Pawel,

Thanks very much for writing the redirect extension we've all been waiting for.
 You might try getting some code from Luke Ross, to compare, as he did some work
as well on this in the recent past.

You'll notice I call it redirect and not bounce - if you've read through the
discussion on this bug you'll know why, otherwise I'll give a brief recap.  A
name is a simple thing to change before release, but once it's set it affects a
lot about how a feature is understood.  Why do I spend so much effort on such a
seemingly trivial 'window dressing'?  Because I have a strong interest in user
interfaces and ergonomics.  Redirect says exactly what it does.  Bounce can be
misinterpreted as sending it back to the originator.  The fact that some people
know the feature from other programs as 'bounce' should not hamstring us here. 
The connection (to the 'wrong' terminology, for those who need it in order to
find the feature) can be made by adding keywords to the extension's blurb on the
website, and in the helpfiles (e.g. "also known as bounce from other programs"),
but I strongly feel we should call it only "Redirect" in the interface.

I'd like to take a look also, but I'm in the midst of migrating from Mozilla
Mail to Thunderbird - will it work as an extension for Thunderbird as well? 
Thanks for making it an extension, I think that addresses many of the concerns
voiced above that it should not be available by default, only for those who know
to look for it (and thus what it is that they want).
Comment 193 David :Bienvenu 2004-08-04 07:23:51 PDT
Pawel, thx for trying this - if you can attach the source in source form (e.g.,
zip up your source files and attach that), then it's a lot easier for people to
look at them, w/o installing the xpi
Comment 194 Bartosz Wucke 2004-08-04 11:15:29 PDT
Just rename attachment.xpi to attachment.zip and unzip it.
Same about "chrome/bounce.jar", rename to "bounce.zip" and unzip.
Comment 195 localhost 2004-08-04 14:01:30 PDT
I'm not an expert on the code, just an average user. I'm unable to install this
latest extension. Not in Mozilla nor Thunderbird (both latest nightly). Do I
forget something or should I use a stable release to test this new patch test?
Comment 196 Pawel Krzesniak 2004-08-06 02:35:39 PDT
(In reply to comment #195)
> I'm not an expert on the code, just an average user. I'm unable to install this
> latest extension. Not in Mozilla nor Thunderbird (both latest nightly). Do I
> forget something or should I use a stable release to test this new patch test?

please send me more detailed info about error/problems.
extension was tested with thunderbird 0.7.2 but should work with all 0.7+
versions. I really don't know if with mozilla will be ok.
Comment 197 Hugo Salgado 2004-08-06 06:07:31 PDT
I don't know f it's the same problem, but this happens to me.

When the browser downloads the extension, i got a warning
"Do you wish to install Bounce Messages to your profile?
This will mean it does not need reinstalling when you update
your application. (Click Cancel if you want Bounce Messages
installing to the application directory)"

And then, even with "Ok" or "Cancel", it throws the error:

"Failed to create bounce.jar
You probably don't have appropriate permissions
(write access to your profile or chrome directory).
Error code:-214
"

The browser is Mozilla 1.4 (Mozilla/5.0 (X11; U; Linux i686;
en-US; rv:1.4) Gecko/2003062) on Redhat Linux 9
I'ts the same error with Firefox 0.8.

Hugo


(In reply to comment #196)
> (In reply to comment #195)
> > I'm not an expert on the code, just an average user. I'm unable to install this
> > latest extension. Not in Mozilla nor Thunderbird (both latest nightly). Do I
> > forget something or should I use a stable release to test this new patch test?
> 
> please send me more detailed info about error/problems.
> extension was tested with thunderbird 0.7.2 but should work with all 0.7+
> versions. I really don't know if with mozilla will be ok.
Comment 198 Fabian Rodriguez 2004-08-06 11:09:33 PDT
I downloaded the extension. I tested with several HTML, OpenPGP
encrypted/signed, plain text emails. Works for me! Some suggestions:
 - I also think this should not be called forward. But Redirect makes me think
of URL redirection... Perhaps "Forward as original author" extension would be
much clearer. Several extensions have very long names and I don't have a problem
with that.
 - The CTRL-B shortcut didn't always work. I would prefer "CTRL-SHIFT-L" as this
would be "kind of forwarding" the email (CTRL-L being the current shortcut for
Forward)
 - When it has succeded it should follow the same behavior as sending a message
(close the window).
 - Maybe also make a new button available in the toolbar
 - Provide an option to reset the time stamp of the forwarded message,
permanently (from the options dialog) and per-message.
 - Provide a way to add a prefix to the subject OR the message (such as FW: or
"Originally for: ---") that would indicate this message is being forwarded as
the author.
Comment 199 Chris P. Ross 2004-08-06 11:14:26 PDT
Ref comment #198:
Ugh, no.  It shouldn't be called forward, but I'm find with bounce.  I disagree wholly with your "make it 
more like forward" (CTRL+SHIFT+L) logic.  And it should not, under *no* circumstances, allow you to 
change a darned thing about the message.  Be that date or subject.
Perhaps calling it resend?  I like bounce just fine as a name, tho, since that's what I expect that to 
mean...
Comment 200 Fabian Rodriguez 2004-08-06 11:21:25 PDT
If a message timestamp can not be changed, it could be lost among the dozens of
emails some people receive in their inbox (too "old" to show up). Digital
signatures provide a way to preserve the original content time of creation.

Content of the "BUGS" file:

- bounce command should be unavailable when in offline mode (i suppose, what
  SendLater code won't handle this (it modifies Messaged-Id, etc..))
- ctrl-B combination doesn't work
- add item to forwardAsMenu
- if item in threadTree right-clicked and tried to be bounced, bounce-extension
  refers to selected mails instead right-clicked
- complete DTDs (use bundle_composeMsgs)
- add mail-icons before subject in bounceTree
- [XUL] bad ?reflowing? when moving splitter bounce-toolbar-sizer
- bounce xul overlays are too wide (bounce cmd available from too many places)
- make progress-bar working; add counter "which mail is currently sending" (e.g.
2/4)

- for 1 recipient it works; for more doesn't - investigate
- files aren't deleted after sending (or failure)
- bad non-iso8859-1 characters encoding in resent-to and resent-from

- vk_return in listbox AddressingWidget adds new rows
- VK_ESCAPE should close window
- bounceWindow title is wrong (refered emails count, if one->subject || nothing
|| ??) 
- fcc or not message regards of prefs settings (?always do not fcc?)

- create nice icon to show in extension window
- add <em:updateURL> and <em:iconURL> in install.rdf
- ...

- bounce-pref.xul doesn't work


[about]
author: Pawel Krzesniak <email available in the original file>

based on MsgComposeComands.js and addressingWidgetOverlay.js from
mail.jar:messenger/messangercompose
Comment 201 GinoCyber 2004-08-19 13:27:40 PDT
Thanks for this great extension. Here's a few things that I found using TB 0.7
(20040616) under WinXP (no service packs.

1 - ctrl B will not work. The bounce interface does not come up. Could only
bounce  using right click/bounce.

2 - I have 3 accounts set up. No matter which account I use to bounce an email,
the bounced email will allways get stored in the 1st accounts "sent" mail box.

3 - any chance on adding this into the filters? please please please :-)(In
reply to comment #188)
> (In reply to comment #184)
> > (personally, I'd still vote for 'redirect'), but what about
> > something like "forward original" or "forward unedited"?  After all, this is
> > probably best presented to the average user as a variation on forwarding.
> 
> Redirect is very different from forwarding, so if it is implememented,
> its name and its UI should be kept separate.  
>   When you forward a message, the "From" header is set to your address, 
>     so when the recipient replies, the reply is addressed to *you*.  
>   When you redirect a message, the "From" header remains the original
>     "From" address, so when the recipient replies, the reply is
>     addressed to the *original sender*.  
> When people do not understand this distinction, it can cause serious
> problems for others.
> 
> As one list author explains:
> <quote> 
>   Why do you insist that RRE subscribers not use the Eudora
>   "redirect" command to pass messages along to others?
> 
>     The Eudora "redirect" command causes me endless headaches, and I
>     do indeed insist that RRE subscribers not redirect my
>     messages. Here is what happens. You redirect an RRE message to
>     person X. Person X then wants to reply to you, thanking you for
>     passing the message along. Their reply, however, goes to me, not
>     you, and I have to respond and explain what the problem is. This
>     happens all the time, and it is a major nuisance.
> 
>     It is true that, by using "redirect", you are protecting yourself
>     against the risk of misdirected replies -- that is, replies that
>     were intended for me. At the same time, however, you are also
>     exposing me to the symmetric version of the same risk -- the risk
>     that I will get replies that were intended for you. That is why I
>     often say that "redirect" is literally immoral. Many
>     non-Eudora-users do not understand the "From: ... (by way of ...)"
>     header fields that "redirect" creates, and experience shows that
>     no amount of explaining will suffice to get the concept across to
>     them. Indeed, many Eudora users themselves do not understand these
>     From: fields; they use "redirect" because they think it's just
>     like "forward" but without those unsightly ">" intendations.
> 
>     And that's not all. When people redirect RRE messages to other
>     mailing lists, I frequently get messages saying, "who are you and
>     why are you posting to our mailing list?". I don't like having to
>     respond to these messages, explaining that I had never heard of
>     their mailing list and never sent anything to it, when as far as
>     they can tell they have incontrovertible proof to the contrary
>     sitting right in front of them. I also frequently get error
>     messages that are automatically generated when someone redirects a
>     message of mine to a mailing list that includes some bad
>     addresses.
> 
>     I have taken these issues up with Qualcomm, which markets
>     Eudora. They were completely unresponsive. Their approach was that
>     it was unthinkable that any functionality should be removed from a
>     program, and they asserted that any misuse of the command was the
>     fault of its users. I disagree. Putting the "redirect" command
>     where beginners can find it is like leaving a loaded handgun lying
>     around, disguised as a coffee mug. It's bad design. "Redirect"
>     should be understood as a type of forgery.
>                (from http://polaris.gseis.ucla.edu/pagre/rre-faq.html)
> </quote>  
> 
> The need for redirect in the instances I've heard would be 
> reduced if Mozilla allowed the recipient reply to a forwarded attachment
> message.  Currently Moz1.8a2 lets you open the attached message, but in the
> opened view the reply buttons are disabled.  (Anyone know why?)
> 
> If redirect is implemented, the default UI should be designed so it is
> significantly easier to do a 'forward-attachment' than to do a 'redirect', so
> people will not use 'redirect' when a 'forward-attachment' would do. 
> (Customization may allow people who know they really want a 'redirect' to change
> this.)
> 
> If redirect is implemented, there could be some safeguards against mistakes like
> above.  One idea is a whitelist of email addresses which can be redirected.  The
> whitelist would be initialized with the user's email account address(es).  The
> idea is to allow the user to redirect messages addressed personally to the
> user's account(s), but not messages directed to a mailing list (at least not
> without the user doing some extra work to add it to the whitelist).
> 
> 
> 

Comment 202 GinoCyber 2004-08-19 13:30:52 PDT
Thanks for this great extension. Here's a few things that I found using TB 0.7
(20040616) under WinXP (no service packs.

1 - ctrl B will not work. The bounce interface does not come up. Could only
bounce  using right click/bounce.

2 - I have 3 accounts set up. No matter which account I use to bounce an email,
the bounced email will allways get stored in the 1st accounts "sent" mail box.

3 - any chance on adding this into the filters? please please please :-)
Comment 203 GinoCyber 2004-08-19 18:44:32 PDT
Me again. 
 
Disregard item #2. It works fine. 
 
I just tried yoru extension in Mandrake 10.0 and also 10.1 beta with TB 0.7+ 
(20040818). Installation went fine but it doesn't do anything. The bounce GUI 
comes up fine but when I click on the4 send button, it's not sending. The 
status bar at this point remains empty. 
 
Also ctrl-B doesn't work. Have to right click and select bounce. 
Comment 204 Pawel Krzesniak 2004-08-23 06:42:42 PDT
hi all,

1. after suggestions, the name of extension evolved. now it's "mailredirect"
2. i made project home page at http://mailredirect.mozdev.org
3. there is mailing list for the project
4. 0.0.5 version released -- some bugs killed (but not all critical)

-- 
Pawel
Comment 205 GinoCyber 2004-08-23 13:49:24 PDT
Thank you sir!!!!

ctrl-B works fine under XP. I'll try Mandrake tonite when I Get home.

Another suggestion if possible. RIght now, re-directing to multiple users does
work for me under XP but each user does not see who else got the email. 

Just wondering if it's possible to re-direct an email to many recipients and all
recipients actually see the entire 'To' list.

Another feature that would be nice but not a big deal is if we are able to 'CC'
or 'Bcc' a recipient when I re-direct.

Regarding those 3 new headers (Resent-From:, Resent-To: and Resent-Date:), where
am I supposed to see them?

Comment 206 GinoCyber 2004-08-23 17:08:13 PDT
Just tried it in Mandrake 10.0 and the behaviour is the same as what I 
previously reported. 
Comment 207 Fabian Rodriguez 2004-08-30 21:24:01 PDT
Nicely done. When listing the extensions under Tools|Extensions, the URL still
points to this bug. It should be changed to http://mailredirect.mozdev.org/ , no ?
Comment 208 Pawel Krzesniak 2004-08-31 07:11:54 PDT
I've just released 0.0.6 version of mailredirect extension
http://downloads.mozdev.org/mailredirect/mailredirect.xpi

I need some help on following problem:
Resent-{to,from} headers must be quoted-printable encoded. I have not found
javascript method which can do it. There is
nsIMimeConverter.encodeMimePartIIStr() but
Components.classes["@mozilla.org/messenger/mimeconverter;1"] has no
nsIMimeConverter interface. Is this a bug or I missed something?
code:
http://lxr.mozilla.org/mozilla/source/mail/extensions/newsblog/content/FeedItem.js#289
uses MimeConverter as I would like to. How can I encode Resent-*: headers?

thx
Comment 209 Karsten Düsterloh 2004-08-31 08:14:44 PDT
As the "/mail/" in the path to FeedItem.js suggests, the interface
nsIMimeConverter is not (yet) available in MailNews, only in Thunderbird.
Comment 210 Chris P. Ross 2004-08-31 08:17:51 PDT
I downloaded 0.0.6 and it works just fine for me.  The only suggestion I'd make
is capitalizing the other word components of the Resent-* headers.  I see
"Resent-from:" and "Resent-date:", and am used to seeing "Resent-From:" and
"Resent-To:" etc.  Doesn't hurt, but seems more consistant that way.
Also, when I hit the "redirect" button, it sent the redirect, and left the
redirect message window open.  Is this a known bug?
Comment 211 David :Bienvenu 2004-08-31 08:34:23 PDT
>As the "/mail/" in the path to FeedItem.js suggests, the interface
>nsIMimeConverter is not (yet) available in MailNews, only in Thunderbird.

That just means that rss feed reading code is part of thunderbird. It doesn't
say anything about whether nsIMimeConverter is available in Seamonkey vs.
Thunderbird, since they share the same backend code, where nsIMimeConverter is
implemented.
Comment 212 Karsten Düsterloh 2004-08-31 09:40:39 PDT
>>As the "/mail/" in the path to FeedItem.js suggests, the interface
>>nsIMimeConverter is not (yet) available in MailNews, only in Thunderbird.
> 
> That just means that rss feed reading code is part of thunderbird. It doesn't
> say anything about whether nsIMimeConverter is available in Seamonkey vs.
> Thunderbird, since they share the same backend code, where nsIMimeConverter is
> implemented.

Mmh, I just feared that my sentence was ambiguous as soon as I had sent it. ;-)
Of course, the usage of the interface in TB doesn't say anything about the
availability in SM. But the JS Components.interfaces object does not know about
nsIMimeConverter in SM... (At least my two(?) weeks old debug version does not.)
Comment 213 Ilan Finci 2004-09-01 00:37:36 PDT
I've tried version 0.5 & 0.6, on ThunderBird 0.7.3, installed on linux, and have
few problems:

1. I cannot use CTRL+B to bounce, just the menue entry.
2. In no mail is selected, and I press the right button on an email, I can open
the bounce window, but with no mail listed to be bounced.
3. When trying to bounce an email, the status line of the bounce window shows:
"Delivering mail..." and the window stay open for few minutes, after which I get
an error message about a timeout, and the mail was not bounced.

Any idea?
Comment 214 Pawel Krzesniak 2004-09-02 03:56:49 PDT
(In reply to comment #212)
nsIMimeConverter works in thunderbird 0.7+ (20040830). In stable 0.7.3 doesn't.
Neil Parkway enlightened me.
Comment 215 Pawel Krzesniak 2004-09-03 02:46:39 PDT
(In reply to comment #210)
> The only suggestion I'd make
> is capitalizing the other word components of the Resent-* headers.  I see
> "Resent-from:" and "Resent-date:", and am used to seeing "Resent-From:" and
> "Resent-To:" etc.  Doesn't hurt, but seems more consistant that way.
it is capitalized.

> Also, when I hit the "redirect" button, it sent the redirect, and left the
> redirect message window open.  Is this a known bug?
yep.
Comment 216 Pawel Krzesniak 2004-09-10 04:14:07 PDT
version 0.1 of mailredirect extension available on http://mailredirect.mozdev.org/

in my opinion it works stable. 
please try it -- maybe we could close bug #12916 after five years..

waiting for comments on mailing list http://mailredirect.mozdev.org/list.html or
newsgroup news://news.mozdev.org/public.mozdev.mailredirect (mozdev/maduser)
Comment 217 Ronny Adsetts 2004-09-11 02:30:24 PDT
A couple of points on the 0.1 extension:

* Extension window should close after bounce is sent (maybe??)
* Nothing is saved to the sent items folder
* There is no indication from the mail icon that it has been bounced

Other than that, it's a top extension! Thanks very much!
Comment 218 katip 2004-09-12 05:58:33 PDT
(In reply to comment #217)
> A couple of points on the 0.1 extension:
> 
> * Extension window should close after bounce is sent (maybe??)
> * Nothing is saved to the sent items folder
> * There is no indication from the mail icon that it has been bounced
> 
> Other than that, it's a top extension! Thanks very much!

It doesn't work on messages saved on local folders. Previous version did.
0.7.3 (20040803)
Comment 219 Ilan Finci 2004-09-12 06:15:32 PDT
I've installed version 0.1, and still, no re-directing is possible.
I select a message, redirect it, and after a long time get an error that it was
not sent, and to check my account setting.

I'm using TB 0.7.3 on linux.

Any idea?
Comment 220 Pawel Krzesniak 2004-09-14 05:30:23 PDT
if there are any problems PLEASE open JavaScript Console and tell me what are
the error messages.

(In reply to comment #219)
> Any idea?
any messages on console?

(In reply to comment #218)
> It doesn't work on messages saved on local folders. Previous version did.
> 0.7.3 (20040803)
since version 0.1.3 works again

(In reply to comment #217)
> * Extension window should close after bounce is sent (maybe??)
it is. but there was a little bug with closing - in 0.1.4 it will be better.

> * Nothing is saved to the sent items folder
is checkbox in preferences windows checked?

> * There is no indication from the mail icon that it has been bounced
do you think it should?
what do the others think?
Comment 221 Ronny Adsetts 2004-09-14 06:54:09 PDT
> > * Extension window should close after bounce is sent (maybe??)
> it is. but there was a little bug with closing - in 0.1.4 it will be better.

I'll watch out for this then,

> > * Nothing is saved to the sent items folder
> is checkbox in preferences windows checked?

No extension preferences under TBird 0.7.x. Have it now under 0.8. Thanks

> > * There is no indication from the mail icon that it has been bounced
> do you think it should?

Well, Reply and Forward both set icon overlays. It would be consistent for
Redirect to do the same. It would mean that you could see at a glance whether
emails had been Redirected.

It would obviously have to work graphically with both the other overlays and
match their appearance stylictically. I'm no graphic designer though I may be
able to knock up something rough if required (I do know my way around photoshop).
Comment 222 Chris P. Ross 2004-09-16 09:26:43 PDT
Excellent.  Just tested 0.1.5 on my Thunderbird 0.7.1 (Solaris).  I look forward
to getting a SPARC/Solaris 0.8 build and using it there.
One comment, tho.  It just has a "name" field in the window.  Should it put a
"Resent-To:" label in front of it?  No reason for a drop-list, but just
indicating what that field is might be a good thing...
Thanks again!!!  Any chance of this getting committed to the core functionality?
 Or is it considered too limited desireability?
Comment 223 Pawel Krzesniak 2004-09-23 06:51:37 PDT
(In reply to comment #222)
> Any chance of this getting committed to the core functionality?
i doubt, but last word is not mine.
ask ducarroz, maybe. if he agree i'll happy :)

sspitzer said "[should be a mailnews extension]"..

btw: version 0.1.6 is available
Comment 224 Mike Cowperthwaite 2004-10-02 08:08:00 PDT
*** Bug 262564 has been marked as a duplicate of this bug. ***
Comment 225 Mike Cowperthwaite 2004-11-04 11:08:27 PST
*** Bug 267758 has been marked as a duplicate of this bug. ***
Comment 226 Jan Lausch 2004-12-07 05:41:50 PST
It seems that it's not possible to install mailredirect.xpi (0.5) in TB 1.0 nor
in 1.0 RC 1 (german).
There is a message that says "...couldn't install ... because it's not
compatible to this version of TB (..only compatible to Thunderbird Versions 0.7
- 0.9+[!!])

This seems to be a bug in the way the version information is calculated; so I
guess it shouldn't be a big deal to correct it.
I also noticed this at another extension
(http://forums.mozillazine.org/viewtopic.php?t=153392) so it really should be
thought about this version information thing...

Greetings, Jan
Comment 227 Fran Boon 2004-12-09 06:21:32 PST
OK, so the Extension now works with 1.0:
http://www.mozdev.org/pipermail/mailredirect/2004-December/000127.html
If installed correctly:
http://mailredirect.mozdev.org/installation.html

Now that we're post-1.0, is there any chance of this key feature making it into
the core?

F
Comment 228 R.K.Aa. 2004-12-13 14:02:41 PST
*** Bug 274411 has been marked as a duplicate of this bug. ***
Comment 229 Jo Hermans 2005-01-05 04:56:44 PST
*** Bug 277096 has been marked as a duplicate of this bug. ***
Comment 230 Jo Hermans 2005-01-16 10:02:47 PST
*** Bug 278622 has been marked as a duplicate of this bug. ***
Comment 231 Ken 2005-02-14 13:15:43 PST
(In reply to comment #227)

> Now that we're post-1.0, is there any chance of this key feature making it into
> the core?

Anyone?  I would also like to see this common feature make it into the core, still.
Comment 232 Shi Sherebrin 2005-02-14 14:56:30 PST
While I find this feature indispensible, what's wrong with having it as a
separate extension?  Not everyone needs or wants it.
Comment 233 Ron Higgins 2005-02-14 15:08:56 PST
(In reply to comment #232)
> While I find this feature indispensible, what's wrong with having it as a
> separate extension?  Not everyone needs or wants it.

...and how does one install it into Mozilla?  I only see Thunderbird instructions.
Comment 234 Grant 2005-02-14 20:19:30 PST
While extensions are great, it would be nice to have it built into the core. 
After a while, to install the mail client on another computer or reinstall,
you'll need to have to install a dozen entensions to get everything you want. 
With computers getting more powerful and hard drives holding more and internet
speeds making large files easy to download, it would be nice to incorporate the
more requested features directly into the core.  Anyone else agree?

(In reply to comment #232)
> While I find this feature indispensible, what's wrong with having it as a
> separate extension?  Not everyone needs or wants it.

Comment 235 Shi Sherebrin 2005-02-14 20:25:48 PST
I suppose if you're talking about the Mozilla Suite, then sure - as long as it's
left as an extension for Thunderbird, whose philosophy is more along the lines
of "keep everything that doesn't NEED to be core" in extensions"
Comment 236 Rod Vagg 2005-02-14 20:32:29 PST
> "keep everything that doesn't NEED to be core" in extensions"

IMO, this functionality should not be considered peripheral to a modern
mailreader. Failure to implement what is a standard feature of most other email
applications could continue to impact on the broader adoption of Thunderbird and
Mozilla.

If the mantra really is "keep everything that doesn't NEED to be core in
extensions" then how did Junk controls and RSS make it in? I would argue that
redirect is much more necessary than these 2 items (and more!) currently in the
core.

We have some code, we have lots of noise and 168 votes, what is the problem here?
Comment 237 Mark Bitterling 2005-02-14 20:42:26 PST
This is a standard email function like Reply or Forward; the bug has been filed against "Core."  I suspect 
that the majority of the 168 voters for this bug would like to see it implemented in the core Mozilla 
code, but it is not necessary for everyone to spam the bug with their vote on whether or not it should 
be in the core. 

If someone is prepared to code the patch to implement it in the core, then post to the bug.  
Otherwise, unless someone tries to close the bug prematurely, this is not the proper forum to discuss 
advocacy of the bug.
Comment 238 Pawel Krzesniak 2005-02-14 23:54:13 PST
(In reply to comment #233)
> ...and how does one install it into Mozilla?  I only see Thunderbird instructions.

cite from project homepage: "The mailredirect extension for Mozilla Thunderbird
(version 0.7 and above) and Mozilla Mail client adds..."

(In reply to comment #235)
> I suppose if you're talking about the Mozilla Suite, then sure - as long as it's
> left as an extension for Thunderbird...

it isn't. if mailredirect doesn't work with mozilla suite let me know.

(In reply to comment #237)
> If someone is prepared to code the patch to implement it in the core, then
post to the bug.  

will this job appreciated? for me Whiteboard Status is clear.
Comment 239 gekacheka 2005-02-15 07:08:46 PST
See comment #188 for some ways redirect can cause more grief to the original
sender and the recipient than the person using it.  

If implemented, several safeguards should be added to guard against
inappropriate use.  Safeguard ideas include:

 * Make it an extension so mostly only users that understand it and need it will
install it and use it (what we have now).

 * Make it hidden by default, so mostly only users that understand it and need
it will change the preference or customize the menu/tool bar and use it.

 * Use an originally-to whitelist by default, so users can only redirect
messages sent to their email address(es), and cannot easily redirect by mistake
a message originally sent to a wide mailing list.

 * Use a redirect-to whitelist by default, so users can only redirect messages
to specific addresses (such as people in their organization, initially empty),
and cannot easily redirect by mistake to a wide mailing list.

 * Make it harder to use by default than forwarding as attachment.   One way is
to add a confirm box that explains how redirect is different from forwarding and
how it can cause grief to others).  Maybe something like
--------------------
Are you sure you want to redirect this message?  

Redirect should generally be used only when the receiver expects to receive
redirected mails.

The redirected message will be From: <sender's-email>, not from you,
so all replies and complaints will go to <sender's-email>, not to you.
To avoid this, forward the message as an attachment instead.
  [[Forward as attachment]] [Redirect] [Cancel]
--------------------
Comment 240 Ben Bucksch (:BenB) 2005-02-15 08:17:53 PST
>  * Make it harder to use by default than forwarding as attachment.

Forward is a toolbar button. I assume Redirect would not be, so this is already
fulfilled. People who use redirect frequently can use a keyborad shurtcut, which
is probably faster than a toobar button anyways, given that you have to enter or
select the redirect address anyways.
Comment 241 Kurt Huwig 2005-02-15 08:45:05 PST
I would like to have the possibility to get it like it is now, i.e. a separate
button in the toolbar. We are all experienced people here and we need this
feature for some "switchboard" functionality for mails from customers that are
directed to the wrong person. A redirected mail can be answered much more easily
than a forwarded mail. With a forwarded mail I have to edit the recipient, so
that the mail goes to the customer and not to my co-worker. Then I have to edit
the subject to remove the "Fwd:". Then I have to remove the body to get rid of
the headers. Altogether a real pain in the ass.
Comment 242 Josh Birnbaum 2005-05-31 07:59:00 PDT
*** Bug 296068 has been marked as a duplicate of this bug. ***
Comment 243 Nick Fankhauser 2005-06-01 01:58:54 PDT
So whats the current status on this?
Comment 244 localhost 2005-06-01 02:21:15 PDT
(In reply to comment #243)
> So whats the current status on this?
> 

There will probably will be no change to the mailclient to get this in. The
requested features are (partly) covered by the mailredirect extension available
at http://mailredirect.mozdev.org/.
Comment 245 Wolfgang Rosenauer [:wolfiR] 2005-06-01 02:30:07 PDT
As I do really think that this feature is a basic feature of a MUA, what can be
done to get this small addition in the base of Thunderbird?
Comment 246 Johannes Kastl 2005-06-01 05:29:44 PDT
Please dont forget the good old Mozilla Suite aka Seamonkey. The extension is
working with it, but you can see that it is designed for TB.
Comment 247 Wayne Woods 2005-06-01 05:45:23 PDT
I think it's an important core feature too, but whether it's ultimately included
within Thunderbird depends on the decisions of the developers. The rest of us
can't do much more than cast a vote (above) in support of it. :)

As for better Seamonkey support in the plugin... you should contact the plugin
owners and ask. They won't necessarily read this bug report.

cheers
Comment 248 Nick Fankhauser 2005-06-07 06:21:35 PDT
I also think it's a essential (core) feature, but having it as an extension is
also good!
But there is one thing to the extension: It would be nice, if an email that you
redirected would be only in the send folder, not in incoming anymore. Or at
least that the message's status would be "replied" or "forwarded".
Comment 249 Jean-Michel Reghem 2005-09-15 23:51:30 PDT
i think also this is a major feature needed in the core of TB ...
But, by waiting, i whish to have this extension compatible with TB 1.5 beta 1 !!!

It is not working with this version and i miss it :-)
Comment 250 Pawel Krzesniak 2005-09-16 00:19:11 PDT
(In reply to comment #249)
> But, by waiting, i whish to have this extension compatible with TB 1.5 beta 1 !!!

it will. just a little patience.
Comment 251 Henrik Gemal 2005-12-19 06:08:50 PST
Shouldn't this bug be closed since the functionality is available as an extension?
Comment 252 TGOS 2005-12-19 12:49:34 PST
This bug is about having the functionality as build-in part, not as extension. It is one of the standard mail functionalities you will find in *every* mail client by default, except Thunderbird.
Comment 253 David :Bienvenu 2005-12-19 13:07:24 PST
> one of the standard mail functionalities you will find in *every* mail
> client by default
I know of a couple mail clients off the top of my head that don't have filter redirect functionality - Outlook Express and Outlook.
Comment 254 Marcus Augustus Alzona 2005-12-19 13:32:54 PST
Actually, Outlook (2003) does have Resend functionality AFAIK.  Look for it when viewing an individual message - in the "Actions" menu - "Resend This Message..."

When you select it, you are presented with a Yes/No dialog stating "You do not appear to be the original sender of this message.  Are you sure you want to resend it?"

Isn't it interesting that this feature is now in Outlook of all places, but after six years of this bug being open in Bugzilla we still can't seem to agree to just put it in?
Comment 255 David :Bienvenu 2005-12-19 13:46:24 PST
I said filter redirect, not UI redirect. If you want to resend an e-mail message in tb w/o filters, edit | message as new and change the to: field...It will be a new message, of course. I looked at my Outlook 2003 and it doesn't offer a resend ui action, though perhaps that feature's only available with the exchange server? Or my version of 2003 is missing something...
Comment 256 Rick Russell 2005-12-19 13:56:00 PST
If you can't find the Resend feature in Outlook, try opening the message first (not just selecting it) and go to the Actions menu.

FYI, Outlook's "Resend" feature is not the equivalent of a bounce or redirect. Although it preserves the original From header (which is good), it discards just about everything that is not immediately visible, including any custom X-headers. So it's useless for SPAM reporting/training, one of the major functions of a bounce feature.

It sure would be nice if we could get a stable version of the Redirect extension (http://mailredirect.mozdev.org/) in the core code. That extension is apparently unmaintained, and it's also unstable when redirecting large numbers of messages.
Comment 257 Johannes Kastl 2005-12-19 14:02:01 PST
I think it is very important to have a possibility to really forward the original message. Not resend it, and not bounce spam in this way, as some people fear.

I need this a lot for sending mails to other people, especially when checking signatures in enigmail or similar.

And I think it is not that far out, so there is (from my view) no problem to put it in.
But Im glad if the extension/addon works.
Comment 258 David :Bienvenu 2005-12-19 14:06:03 PST
In 1.5, you can forward it as a filter action, and of course, you can forward it manually withe ui.
Comment 259 Alan Dobkin 2005-12-19 14:08:07 PST
Surely you are not suggesting that we should follow Microsoft's lead and leave important features out of Thunderbird just because they did.  Such a policy would have prevented many other great features that have been added already.

The previous poster was obviously overstating by saying this feature is built-in to every e-mail client by default.  Nevertheless, it is built-in to many/most other clients, and it is certainly a desired feature to have in Thunderbird, judging by the duration of this bug and number of comments.

Personally, I don't mind having to add the extension, since it has worked well so far.  But I would certainly prefer to have it integrated into the core program, even if it is considered an "advanced" feature that is not easily-accessed.

P. S. -- I just realized how difficult it is to post a comment when other people are adding comments at the same time!
Comment 260 David :Bienvenu 2005-12-19 14:11:01 PST
Obviously that's not the policy - we have a lot of features that aren't in Outlook or OE! But I couldn't let that statement go unchallenged since it made me LOL :-)
Comment 261 Alan Dobkin 2005-12-19 14:20:09 PST
> I said filter redirect, not UI redirect. If you want to resend an e-mail
> message in tb w/o filters, edit | message as new and change the to: field...

David, it sounds like you are misunderstanding the request in this bug.  As stated by the poster way back in comment #6 on 4/4/2000, "I don't believe this blocks Bug 11769.  This is entirely different and not filter based."

To clarify my own position, I agree that having this feature as a filter action is NOT a good idea, but having it as a manual action to redirect individual or a group of selected messages IS desired.
Comment 262 Alan Dobkin 2005-12-19 15:17:43 PST
There is a great summary on the SpamAssassin wiki explaining why this feature is necessary and what e-mail clients have implemented it already.  Sadly, aside from AOL, Thunderbird and Outlook Express (NOT Outlook) are two of the only clients that are missing this capability.

http://wiki.apache.org/spamassassin/ResendingMailWithHeaders?highlight=%28redirect%29

Please note that reporting spam is not the only purpose for this feature.  It is also used in LISTSERV administration and many other instances, but this web page is one popular example.
Comment 263 TGOS 2005-12-19 17:12:46 PST
I said every mail client has a redirect function, at least every serious one (leaving aside some mini freeware or shareware clients, that miss pretty much 80% functionality of a serios mail client anyway). It is like saying every browser has a bookmark funcition, which certainly does not hold true for some browsers, but these are not considered serious, productive software. Who would want to use a browser without bookmark functions and what for? That's the same with redirect in a mail client.

And yes, Outlook has redirect, for ages. Does it keep all the headers? Who cares? Where is written that a redirect means you must keep all the headers? Who defines that term in such a way? Who said it may not be a "new" message? I don't care for any of these features.

A redirect is a mail that I got and resend to a different address in such a way, that the *body* of the mail stays completely untouched and the mail *appears* to come from the original sender and not from me. _That_ is what I expect of a redirect, nothing less, nothing more. If it also keeps all headers, okay, fine, but I don't expect that. Nor do I know if that is a good idea (as my mail server may refuse that I send mails with certain headers in it, while the mail server of the original sender did not and my mail server did not care as receiver). As long as this will never block me from redirecting a mail, keep all headers if you like.

The point is, I often get mails in my personal mailbox, that should have gone to a ticket system in our company or that should have gone to a different person in my company. If I forward these, the ticket system will get confused and make me the ticket owner and all replies go back to me and not to the *real* sender of the ticket. Same happens if I forward it to other people and they just hit reply. The only way working around that is creating a new mail, setting the original senders address into the reply-to header and copy/paste his text to the new mail; and that all manually. Still, I will be the ticket owner in the ticket system, as it's still my from line in the header and that's what the ticket system cares for. So the original sender gets a reply, but the salutation contains my name. That's why I can't use Thunderbird at work and still have to use Apple Mail instead (or I could use MS Entourage, pretty much Outlook for Mac).
Comment 264 Chris Rebert 2005-12-19 17:17:43 PST
I'd say that the average home or office user doesn't need/use this feature.
The main people who use this feature are power-users who bother to report spam and some office people who user it as comment #1 describes.
Judging by how most people won't use this, I think this is fine as an extension. Just place a link to it on some FAQ page and add an explanatory comment here.
Comment 265 TGOS 2005-12-19 18:10:40 PST
"I'd say that the average home or office user doesn't need/use this feature."

The average home or office user does not need 50% of all other feature TB has, too. Still we are not throwing them all out because of that, are we? And who are you to actually define what the average home or office user needs and what not? I wouldn't dare to define that for the rest of the world. This bug has 200 votes, looks like there are in fact some average users who care for it. How many other bugs (which you would call much more important for the average home or office user) have not even 100 votes?

So not everyone needs it, okay, don't put into the toolbar by default. Make people first customize their toolbar if they need it. Or don't offer it as toolbar item at all, make it a menu entry. This bug is only about the fact that it should always be there by default (without installing any extension, that will not work together with your versions... I have only made very bad experiences with extensions in Firefox), not about the fact that it must directly hit the eye in blinking neon when you open TB for the first time as average home or office user.

So what do you weed to have people take this bug seriously if 200 votes are not enough? Add a bounty to it? Okay, I throw $5 into the bowl for the person who gets the patch into the tree or for the Mozilla foundation if the programmer wants to donate it for the well of the project.
Comment 266 Jean-Michel Reghem 2005-12-19 23:53:35 PST
(In reply to comment #264)
> I'd say that the average home or office user doesn't need/use this feature.

OK for power user which uses this for Spam report or redistribution of mails going to adress like support@xxx.yy

But i'm an office user, and i use the extension for this: some html mails i need to forward (with embedded images, etc...) are not well forwarded, and the final received mail is really unreadable. With a "resend" and not a "forward", i can make follow the mail without destroy it.

This extension is really integrated into TB: an icon which is completly integrated with other originals icons, a menu entry, etc ... it is working well, and i don't know why it is not yet integrated into the core ... All the major job is already done, but, as it is an extension, it is not yet available for 1.5  RC1 or RC2 as max version is 1.4 and not 1.5.0.* --> so, without nightly tester tools, lambda user which use RC1 and want to use the extension cannot do.

Comment 267 Andrés G. Aragoneses 2005-12-20 00:00:53 PST
> The average home or office user does not need 50% of all other feature TB has,
> too. Still we are not throwing them all out because of that, are we? And who
> are you to actually define what the average home or office user needs and what
> not? I wouldn't dare to define that for the rest of the world. This bug has 200
> votes, looks like there are in fact some average users who care for it. How
> many other bugs (which you would call much more important for the average home
> or office user) have not even 100 votes?

I agree with this. And we have to say also that perhaps the reason of this feature not being necessary for most of the people is its unavailability! If more people find it out in the TB core perhaps it becomes more used and more demanded.

Just my 2 cents.
Comment 268 Pawel Krzesniak 2005-12-20 00:48:39 PST
(In reply to comment #263)
> And yes, Outlook has redirect, for ages. Does it keep all the headers? Who
> cares? Where is written that a redirect means you must keep all the headers?

RFC2822 section 3.6.6:
   Resent fields SHOULD be added to any message that is reintroduced by
   a user into the transport system.  A separate set of resent fields
   SHOULD be added each time this is done.  All of the resent fields
   corresponding to a particular resending of the message SHOULD be
   together.  Each new set of resent fields is prepended to the message;
   that is, the most recent set of resent fields appear earlier in the
   message.  No other fields in the message are changed when resent
   fields are added.
Comment 269 Alan Dobkin 2005-12-20 07:00:30 PST
As Pawel and others here indicated, this feature has been clearly defined in the e-mail standard RFC 822 (section 4.2) since August 1982 (23 years ago!) and updated in RFC 2822 (section 3.6.6) in April 2001 (4 years ago).  They both state that the existing headers must remain intact.

In addition, this feature is well documented in many other places, such as the SpamAssassin wiki I referred to in comment #262, as well as the home page of the extension that has been created to address this bug, http://MailRedirect.MozDev.org/ , not to mention in many of the comments above.

I also discovered that there is an About.com article (URL below) explaining why this feature is useful for any average home or office user.  I would argue that the mere existance of this article indicates that it is a mainstream action, as the whole purpose of About.com is to "offer practical advice and solutions for every day life."

http://email.about.com/cs/usingemail/a/redirect.htm

For all of these reasons, especially the fact that this functionality has been part of the standard e-mail specification for over 20 years, I think there is a valid and strong case why a redirect option should be built-in to the Thunderbird core program.
Comment 270 Aleksey Nogin 2005-12-20 09:09:45 PST
(In reply to comment #262)
> There is a great summary on the SpamAssassin wiki explaining why this feature
> is necessary and what e-mail clients have implemented it already.  Sadly, aside
> from AOL, Thunderbird and Outlook Express (NOT Outlook) are two of the only
> clients that are missing this capability.
> 
> http://wiki.apache.org/spamassassin/ResendingMailWithHeaders?highlight=%28redirect%29
> 
IMHO the above page is simply wrong - "Forward as Attachment" does forward messages with all the headers intact and a procmail recipee very similar (if not identical) to the one they give for Novell GroupWise would work.

Message bounce is a useful feature, but let's not give wrong/misleading reasons for wanting it.

P.S. Sorry for adding to noise level - I wish bug 225751 (special area for non-technical/political comments) was implemented...
Comment 271 Alan Dobkin 2005-12-22 07:58:17 PST
(In reply to comment #270)
> > http://wiki.apache.org/spamassassin/ResendingMailWithHeaders
> > 
> IMHO the above page is simply wrong - "Forward as Attachment" 
> does forward messages with all the headers intact

Then you are misunderstanding how this works.  "Forward as Attachment" creates an entirely *new* message with *your* e-mail address, server, etc. in the headers.  Yes, it preserves the headers of the original message in the attachment, but the message itself (which is what is processed by the spam reporting engines, etc.) is now coming from you, and your address becomes the one registered as the spam source in this example.

> and a procmail recipee very similar (if not identical) to the one they 
> give for Novell GroupWise would work.

Procmail is a wonderful and very powerful tool, but it is no substitute for redirect functionality built-in to a mail client.  For one, it is not universally available, since it requires a shell account (which most people don't have) and knowledge how to use it.  Secondly, this is obviously a last resort hack in the Groupwise example because it has been converted to an internal format that is otherwise unusable.

> Message bounce is a useful feature, but let's not give 
> wrong/misleading reasons for wanting it.

No offense, but apparently you don't fully understand the reasons (and there are many) why it is a necessary feature.  After reading though most of the comments in this very long bug report, I haven't seen anyone pose a single reason why this *shouldn't* be implemented, especially since Pawel has already developed it as an extension.  Someone just has to step up to the plate and commit to adding this feature into the core program.
Comment 272 Kurt Huwig 2006-01-13 00:29:59 PST
The extension does not work with Thunderbird 1.5 as version <= 1.4. Any plans in this direction?
Comment 273 Jean-Michel Reghem 2006-01-13 02:00:05 PST
The extension works if you force compatibility with Nightly tester tools (http://users.blueprintit.co.uk/~dave/web/firefox/buildid/nightly.html) ...
I'm using it since 1.5 beta2 without problem

But this is not really for end user, this is why I find that it shouldn't be an extension but a component of TB ...
Comment 274 Pawel Krzesniak 2006-01-13 02:26:15 PST
(In reply to comment #272)
> The extension does not work with Thunderbird 1.5 as version <= 1.4. Any plans
> in this direction?

CVS snapshot is compatible, but I haven't tested it heavy.
http://downloads.mozdev.org/mailredirect/mailredirect-cvs.xpi
Comment 275 Magnus Melin 2006-01-13 13:52:52 PST
*** Bug 323249 has been marked as a duplicate of this bug. ***
Comment 276 Wayne Woods 2006-03-13 20:58:53 PST
This should be in consideration for Thunderbird 2, so requesting a block.

Can anyone produce an updated patch? Even if it's not a final version, it'd be useful. That should make it much more likely to get in. Otherwise, as the deadline approaches it'll be summarily denied because of a lack of patch if for no other reason. Like any feature request with no specific developer focusing on it.
Comment 277 Wayne Woods 2006-03-13 21:06:32 PST
Ugh. I really didn't mean to change the component. Sorry for bug spam.
Comment 278 gekacheka 2006-03-14 06:49:32 PST
Bug 204350 appears to be fixed in TB2.0a (it prevented replying to a message forwarded-as-attachment).

So users can forward-as-attachment and recipients using TB2.0a can now reply to the attachment (open the attachment and then reply), addressing the issues raised in the about.com article (comment 269).  For casual users, forward-as-attachment avoids the "forgery"-like grief that redirect can cause for the original sender and the recipients more than the user (comment 188).  

If redirect is implemented, using a confirm dialog to suggest/recommend forward-as-attachment as an alternative (comment 239) is now more realistic.
Comment 279 Ted Pavlic 2006-03-14 07:01:32 PST
(In reply to comment #278)
> If redirect is implemented, using a confirm dialog to suggest/recommend
> forward-as-attachment as an alternative (comment 239) is now more realistic.

There are lots of reasons for using a redirect that still make redirecting a desireable feature. This has become even more true now that so many people use GMail as either their primary or backup mail provider. The easiest way to get old mail onto GMail is via a massive redirect. 

Other quality e-mail clients support redirecting (or "bouncing"). Thunderbird needs to include this feature to keep up with them.
Comment 280 Henrik Gemal 2006-03-14 07:15:02 PST
(In reply to comment #279)
> Other quality e-mail clients support redirecting (or "bouncing"). Thunderbird
> needs to include this feature to keep up with them.

I really really think this should only be available as an extension. No "normal" user would ever use this feature.
I really like the simpleness of Firefox and I think that's what made Firefox what it is today. Dont clutter Thunderbird with features that should only be available as an extension.
Comment 281 Ted Pavlic 2006-03-14 07:28:33 PST
(In reply to comment #280)
> I really really think this should only be available as an extension. No
> "normal" user would ever use this feature.

This is not a large and cumbersome new feature. I don't see how adding it to Thunderbird bloats Thunderbird. And more importantly, extensions are used to extend Thunderbird's functionality to do things that are not very common in e-mail clients. Redirecting IS common and is a very simple feature. It doesn't make sense to me to have it only as an extension.

Imagine the one time you need to redirect a message. Does it make sense to seek out, download, install an extension (and restart Thunderbird) just to perform this one redirect? 

I think lots of users use redirecting. I think redirecting is a main-line feature. 

When I think of extensions, I think of something that will render LaTeX in-line (which I think still has not been built; very disappointing). That to me is distinct from implementing a simple redirect (a feature that is one keypress away in, for example, PINE). 
Comment 282 Henrik Gemal 2006-03-14 07:33:04 PST
(In reply to comment #281)
> 
> I think lots of users use redirecting. I think redirecting is a main-line
> feature. 
> 

It would be interesting to actually get some numbers of this. I have no clue on how many uses redirecting.
I personally never heard about anybody requesting it and I have used it myself.
Comment 283 TT 2006-03-14 07:35:17 PST
    I agree with Ted Pavlic.  Redirecting email IS a common operation and it does belong in every email client as a built-in feature.

    While I'm at it, I just want to add that I'd like this feature to be added to Seamonkey.  I don't use Thunderbird / Firefox because of all the extensions one needs to install.
Comment 284 Sebastian Hagedorn 2006-03-14 07:35:57 PST
(In reply to comment #280)
> (In reply to comment #279)
> > Other quality e-mail clients support redirecting (or "bouncing"). Thunderbird
> > needs to include this feature to keep up with them.
> 
> I really really think this should only be available as an extension. No
> "normal" user would ever use this feature.

We must have very different concepts of "normal". I use redirecting at least once per week. I agree that it's a must-have feature for Thunderbird.
Comment 285 Marcel van Beurden 2006-03-14 07:45:28 PST
Some people use it, some people don't. I think we need it, either as standard functionality or as an extension. But I don't think this is the place to have endless discussions about that.
Comment 286 Jean-Michel Reghem 2006-03-14 07:49:12 PST
(In reply to comment #282)

> It would be interesting to actually get some numbers of this. I have no clue on
> how many uses redirecting.
> I personally never heard about anybody requesting it and I have used it myself.
> 

1) it is really helpful for little enterprise which have no large ICT resource or imap emails : just one adress like sales@blabla.com, support@blabla.com, etc... with only one guy reading the mail and redirecting the mail to the good recipients john.doe@blabla.com --> with redirect, John Doe can easily make a reply to the mail, exactly like he has directly received the mail.

I'm using this sometimes ... and need it
Comment 287 Kurt Huwig 2006-03-14 08:04:40 PST
(In reply to comment #286)
> (In reply to comment #282)
> > It would be interesting to actually get some numbers of this. I have no clue on
> > how many uses redirecting.
> > I personally never heard about anybody requesting it and I have used it myself.
> 
> 1) it is really helpful for little enterprise which have no large ICT resource
> or imap emails : just one adress like sales@blabla.com, support@blabla.com,
> etc... with only one guy reading the mail and redirecting the mail to the good
> recipients john.doe@blabla.com --> with redirect, John Doe can easily make a
> reply to the mail, exactly like he has directly received the mail.
> 
> I'm using this sometimes ... and need it

Same for me: I forward mail to our ticket system quite often. A lot of our customers send mail directly to me as the key account manager and I have to redirect it to technical support, accouting etc. Especially with the ticket system, forward-as-attachment is not an option.
Comment 288 Keith Hanlon 2006-03-14 08:17:05 PST
(In reply to comment #287)
> 
> 1) it is really helpful for little enterprise which have no large ICT resource
> or imap emails : just one adress like sales@blabla.com, support@blabla.com,
> etc... with only one guy reading the mail and redirecting the mail to the good
> recipients john.doe@blabla.com --> with redirect, John Doe can easily make a
> reply to the mail, exactly like he has directly received the mail.
> 
> I'm using this sometimes ... and need it
> 


I use redirect every day for this very reason. Even people we do business with regularly will send stuff to our "generic" mail@ address. Redirect gets it to the appropriate party easily.

I'm using the extension, but it doesn't mark which messages have been redirected, the way TB does with forwarding. This function really should be a part of TB 2.0. It's an email standard, and TB should support. Do what Apple Mail does... hide it so regular users won't see it, but have a way for advanced users to turn it on.
Comment 289 Nibbles Dev Team 2006-03-14 09:03:22 PST
> (In reply to comment #280)
> > I really really think this should only be available as an extension. No
> > "normal" user would ever use this feature.

I really, really think this is a basic feature (I use it normally, very handy) and should be part of integrated feature, not an extension.
Comment 290 Peter Flynn 2006-03-14 13:16:00 PST
(In reply to comment #282)
> (In reply to comment #281)
> > 
> > I think lots of users use redirecting. I think redirecting is a main-line
> > feature. 
> > 
> 
> It would be interesting to actually get some numbers of this. I have no clue on
> how many uses redirecting.
> I personally never heard about anybody requesting it and I have used it myself.

As the person who originally requested it, I can only say I need it, and use
it. It's essential for me, and I don't care if it's embedded in Thunderbird
or available as an extension, so long as it can be installed as a toolbar
icon I can click on, and not some menu entry 15 clicks deep. It's HEAVILY
used in tech support, for the reasons given by others.
Comment 291 Wayne Woods 2006-03-14 15:28:07 PST
This conversation has happened many times before on this bug page, so it's not really the place for repeating it. Nothing new is being added, so it's just spamming everyone.... We're all aware of how redirect and forward work, the philosophy behind extensions and the real-world problems with keeping them updated. If you have a strong desire that this feature not be added, please take it to the forums. If you want to evangelize this feature even more than it has been already, also please take it to the forums.

Other than that, if someone has the skill to turn the extension into a patch, please do so! The developers will decide if it should be included or not. There are 210 votes for this bug, which is an exceptionally high number. But if there's no patch, then it'll likely just be ignored for deadline reasons. If they decide it shouldn't be a core feature anyway, then that'll be their decision.
Comment 292 johann.petrak@gmail.com 2006-03-14 15:54:08 PST
(In reply to comment #291)
I agree with everything you said except:

> Other than that, if someone has the skill to turn the extension into a patch,
> please do so! The developers will decide if it should be included or not. 
This is absurd. At least for significant features there should be a decision *before* anyone invests his time to provide a patch. 
If this is really for the developers to decide then what keeps them to decide *now* if a patch that implementes this will eventually go into the tree?

That at least would be the normal way of software development: have a plan before you start to program.
Comment 293 Keith Hanlon 2006-03-14 16:48:49 PST
(In reply to comment #291)
> If you want to evangelize this feature even more than it
> has been already, also please take it to the forums.


Here's a link to the Redirect thread on Mozillazine:
http://forums.mozillazine.org/viewtopic.php?t=109276

Let's take it over there, folks.
Comment 294 Wayne Woods 2006-03-14 20:33:56 PST
(In reply to comment #292)
> This is absurd. At least for significant features there should be a decision
> *before* anyone invests his time to provide a patch. 
> If this is really for the developers to decide then what keeps them to decide
> *now* if a patch that implementes this will eventually go into the tree?

Yeah, I know it sounds kind of absurd, but the mail/news module owners and peers have been fairly quiet on this feature. Nobody has said outright yay or nay, and none of them have taken it over. Which means the best chance currently is to just produce the patch and request a review. It's just the way things seem to work around here. If I knew how to code for Mozilla, I'd do it myself, but I'm only a lay coder at best. If nobody with the skills will do it (and fair enough if they don't want to risk wasting their time), then it'll just have to stay idle for now.
Comment 295 David :Bienvenu 2006-03-14 21:29:09 PST
if a patch showed up that did redirect, I would work to get it into Thunderbird/SM. I just don't have time right now to do one myself.
Comment 296 dennis.lundberg 2006-03-14 23:37:39 PST
(In reply to comment #291)
> Other than that, if someone has the skill to turn the extension into a patch,
> please do so! The developers will decide if it should be included or not. There
> are 210 votes for this bug, which is an exceptionally high number. But if
> there's no patch, then it'll likely just be ignored for deadline reasons. If
> they decide it shouldn't be a core feature anyway, then that'll be their
> decision.

Why can't the currently available extension just be bundled with the normal Thunderbird distribution?

Comment 297 Alan Dobkin 2006-03-15 01:03:44 PST
(In reply to comment #278)
> So users can forward-as-attachment and recipients using TB2.0a can now 
> reply to the attachment (open the attachment and then reply), addressing 
> the issues raised in the about.com article (comment 269).

This is a good point, but it still doesn't eliminate the need for a proper redirect function.  For one thing, it doesn't address the recipients who don't use TB 2.x (or TB at all).  As much as we'd all like to push TB, we can't expect every recipient of our forwarded e-mail to use it.  And it doesn't help with the many other uses of redirect, especially when sending to an automated address, such as for spam reporting or moderating a mailing list.  I've already posted the SpamAssassin example in Comment #262, and here is the LISTSERV example from the L-Soft List Owner's Manual:

http://www.LSoft.com/manuals/1.8e/owner/owner.html#_Toc128536969

To approve postings with the above configuration, the editor simply forwards (or "resends", or "bounces"--the terminology is unclear between various mail programs) the posting back to the list address after making any desired changes to the content. This should be done with a mail program that supports "Resent-" fields; if "Resent-" fields are not found by LISTSERV in the headers of the approved posting, the posting will appear as coming from the editor's address rather than from the original poster.

> If redirect is implemented, using a confirm dialog to suggest/recommend
> forward-as-attachment as an alternative (comment 239) is now more realistic.

This seems like a reasonable warning for first-time users, but it would certainly have to have an option to never be displayed again.  Users who know what they are doing would hate to see this dialog every time they redirect a message.

(In reply to comment #295)
> if a patch showed up that did redirect, I would work to get it into
> Thunderbird/SM. I just don't have time right now to do one myself.

This is very encouraging to hear!  Pawel, now that David has pledged his support, would you be willing/able to resubmit your extension as a core patch?  Or, is there someone else here who can take this on?  It seems that Pawel has done most of the hard work already:  http://MailRedirect.MozDev.org/source.html
Comment 298 Ted Pavlic 2006-03-15 06:22:01 PST
(In reply to comment #296)
> Why can't the currently available extension just be bundled with the normal
> Thunderbird distribution?

The current extension isn't solid. It needs to be fixed itself before it's of the quality required to be distributed.

For example, on the OS X version of Thunderbird, not only is the redirect icon in the main toolbar incorrect, but the icon that links to the address book within the "Mail Redirect" dialog is the spell check icon.
Comment 299 Jo Hermans 2006-04-11 08:04:38 PDT
*** Bug 333583 has been marked as a duplicate of this bug. ***
Comment 300 Scott MacGregor 2006-05-25 14:16:53 PDT
Looks like we're still looking for a patch for this.
Comment 301 Pawel Krzesniak 2006-05-29 00:13:14 PDT
(In reply to comment #300)
> Looks like we're still looking for a patch for this.

I'm working on the patch, but it doesn't go as smooth as I thought it will. Besides I suffer from permanent lack of time :(

Comment 302 Jo Hermans 2006-05-31 05:41:55 PDT
*** Bug 339791 has been marked as a duplicate of this bug. ***
Comment 303 Arkady Belousov 2006-06-02 12:41:05 PDT
(In reply to comment #302)
> *** Bug 339791 has been marked as a duplicate of this bug. ***

Copy&paste for last comment from bug 339791:

> That's not a forward, but a redirect.
> *** This bug has been marked as a duplicate of 12916 ***

     Yes, long (6 years) discussed bug 12916 is what I need. And, I myself,
don't see differences between "forward", "redirect", "bounce" and "resend",
except that "bounce" suggests some automatization.

     Also, in TB there are menus

Message / Forward
Message / Forward as / Part of message

and I not see differences here [because they work currently identically].
Comment 304 Ted Pavlic 2006-06-02 13:16:05 PDT
(In reply to comment #303)
>      Yes, long (6 years) discussed bug 12916 is what I need. And, I myself,
> don't see differences between "forward", "redirect", "bounce" and "resend",
> except that "bounce" suggests some automatization.

A forward comes from you. A redirect (otherwise known as a "bounce" or perhaps a "resend") looks (at least with respect to the main headers) comes from whoever it originally came from.

If I send you a message, it will be From me and To you. You can then "bounce" or "redirect" (a better word, perhaps) it to someone else, and it will show up in that someone else's mailbox; however, it will still be From me and To you. It'll almost I Bcc'd it to the third person. (however, there will probably be a "Resent-To" and possibly a "Recent-From" tag buried in the headers of the message)
 
>      Also, in TB there are menus
> 
> Message / Forward
> Message / Forward as / Part of message
> 
> and I not see differences here [because they work currently identically].

Message / Forward has a hot key attached to it (Apple+L on the machine I'm using now). It is SUPPOSED to be identical to Message / Forward as / Part of Message.

I think your point here is that "Part of message" could be removed and a simple "Forward as attachment" (Shift+Apple+L, maybe?) would be used instead. That's maybe a valid point. (it's just not very Mozilla; I think things are done this way for historical reasons)
Comment 305 Arkady Belousov 2006-06-02 14:55:21 PDT
> > don't see differences between "forward", "redirect", "bounce" and "resend",
> > except that "bounce" suggests some automatization.
> A forward comes from you. A redirect (otherwise known as a "bounce" or perhaps
> a "resend") looks (at least with respect to the main headers) comes from
> whoever it originally came from.

     All of this right, except, that "forward" is wrong word here. What you describe as "Forward", in reality is a deviation of "Reply to other recipient". But further I silent about this - how to _name_ isn't important for me here, here for me matter possibility itself.

> >      Also, in TB there are menus
> > Message / Forward
> > Message / Forward as / Part of message
> > and I not see differences here [because they work currently identically].
> Message / Forward has a hot key attached to it (Apple+L on the machine I'm
> using now).

     ^L (Ctrl-L) on PC.

> It is SUPPOSED to be identical to Message / Forward as / Part of Message.

     Then this is bug in design.

> I think your point here is that "Part of message" could be removed and a simple
> "Forward as attachment" (Shift+Apple+L, maybe?) would be used instead. That's
> maybe a valid point. (it's just not very Mozilla; I think things are done this
> way for historical reasons)

     My previous mailer allows:

1. Forward letter - letter remains intact, only added some Resent-* fields.
2. Forward "from me" - in this case, original letter is included ("Content-Type: message/rfc822") into new letter with new header (with Subject field, equal to original Subject).

In both cases, I may add prefix (like "(fwd)") to Subject field. And, this mailer allows to edit original letter _source_ (in Mozilla, you may do so by exporting to .eml, edit file, to import back), so in reality I may forward anything.

     In Thunderbird, all what it allows, is CREATE NEW letter and (1) include _source_ (with header) of original letter into attachment or (2) insert _body_ of original letter into body of new letter. There is *NO* possibility to FORWARD (resend/bounce/redirect) _original_ letter, so menu name currenly completely misleads users.
Comment 306 Peter Flynn 2006-06-02 15:10:28 PDT
(In reply to comment #304)
> (In reply to comment #303)
> >      Yes, long (6 years) discussed bug 12916 is what I need. And, I myself,
> > don't see differences between "forward", "redirect", "bounce" and "resend",
> > except that "bounce" suggests some automatization.
> 
> A forward comes from you. A redirect (otherwise known as a "bounce" or perhaps
> a "resend") looks (at least with respect to the main headers) comes from
> whoever it originally came from.

As the originator of this request, I should apologise for using the word "bounce", which I used because that's what Elm calls it (the "b" key). There
was NEVER any intention that this request shoulod in any way whatsoever refer
to any kind of automation. Nowadays "Redirect" is the accepted term. It is
unusually disappointing that it is taking so long for such a simple, obvious,
and necessary feature to be added. Its absence currently renders TB useless
as an office mail user agent.

///Peter
Comment 307 software-mozilla 2006-06-08 02:35:16 PDT
This would be so useful to fight spam using dspam!
Comment 308 Stephan Petersen 2007-04-20 01:30:07 PDT
I just installed TB 2.0, it *still* doesn't have a bounce/redirect function! This is really pathetic. Plus, the "Mail Redirect" extension is not (yet) compatible with 2.0. 

Almost 8 years (!) down the line and this important feature is still missing.

Stephan
Comment 309 Christian Hernmarck 2007-04-20 02:55:41 PDT
Hi

I can live with the extension - version 0.7.4 works with Thunderbird 2.0
(new GUID: (un)install manually!!)

To the discussion integrade or not I only can say: the idea of Firefox/Thunderbird was (AFAIK) to have a fast and tiny application with the possibility to install extensions at you own gusto. So: an extension is ok.
But: if every user has to install the extension (and update manually) then some admins wish to have it integrated...
There should be a way to integrate extensions for every user on the same machine...

/ch


Comment 310 Mattias Jiderhamn 2007-04-20 23:23:17 PDT
Created attachment 262329 [details]
mailredirect extension working in TB 2.0
Comment 311 Magnus Melin 2007-07-29 04:01:52 PDT
*** Bug 389889 has been marked as a duplicate of this bug. ***
Comment 312 David Ascher (:davida) 2008-09-25 10:40:30 PDT
We're not blocking on this feature.  AFAIK the backend code is in now, so making an extension for tb3 to enable the UI should be quite simple.
Comment 313 Rimas Kudelis 2008-09-25 13:10:07 PDT
Hm, if the code is there already, why can't we have a toolbar button, that would be disabled by default?
Comment 314 Magnus Melin 2008-09-25 13:33:36 PDT
FYI the non-rfc compliant version backend was implemented in bug 359226. The RFC-compliant version is not yet implemented yet. 

Bryan: any suggestions for where this should be added?
Comment 315 Bryan Clark (DevTools PM) [@clarkbw] 2008-09-25 22:48:11 PDT
The [ other actions | v ] widget on the new headers is supposed to be the place for adding extra message actions that aren't part of the normal routine.
Comment 316 Rimas Kudelis 2008-11-06 00:56:22 PST
So, could we have the „Redirect“ option in "other actions" drop-down, like Bryan suggested?
Comment 317 rsx11m 2008-11-29 16:19:44 PST
(In reply to comment #315)
> The [ other actions | v ] widget on the new headers is supposed to be the place
> for adding extra message actions that aren't part of the normal routine.

I don't think this would be the right primary location for this. Unless there has been a change in paradigm, the headerpane additions introduce a redundancy of features accessible through the main menus and/or the toolbar icons, for those users who like the buttons closer to the message. Thus, the primary spot for a "Redirect" function should be in the "Messages" menu. If wanted, an optional toolbar button could be added to the palette (after all, the toolbar customization was introduced to allow easy access to a feature, but don't have it visible unless it's wanted by a specific user). Only then, if considered important enough, it should show up in the header-pane menu. So, I agree with comment #313 as far as the placement is concerned.
Comment 318 Rimas Kudelis 2009-10-24 11:48:38 PDT
I just want to draw attention to the fact that TB3-compatible version of the extension has been available since September. Perhaps it could be integrated into 3.1 at least?
Comment 319 Martin Donald 2009-12-10 12:24:36 PST
It's been over 10 years for this bug/feature.

I don't care where the button goes, or what it looks like. I want to be able to redirect (bounce) mail. I bounce mail 10 times more often than I forward it. I've bounced mail since the days of elm (I now use mutt as my main mail program). Bouncing is so old that it cannot be so difficult. It should be an integral part of the main code, not just an add-on.

The redirect add-on worked fine in Thunderbird-2 but I have been without it ever since I upgraded to Fedora-11 with THunderbird-3.0b4. 

I use Thunderbird infrequently on my computer but my wife uses it full-time on her machine. If I had the skills I could try to fix the problem myself but I can at least do my bit by participating in the debugging.

Regarding comment #318: Where can I find the TB3 compatible version of the redirect extension?
Comment 320 Jonathan Vanherpe 2009-12-10 12:40:44 PST
http://mailredirect.mozdev.org/

Having this in TB by default would be nice, though.
Comment 321 Peter Flynn 2009-12-10 12:57:37 PST
> It's been over 10 years for this bug/feature.

It certainly has, and if I'd known it would take so long, I'd never have started it.

The Mail-Redirect 0.7.4 add-in for Thunderbird works fine in TB 2.0.0.23 which is why I haven't upgraded to TB3 yet. Redirecting is an essential tool for any professional use of email, and it is regrettable that it is relegated to an add-in instead of being core.
Comment 322 Nathan Tuggy (:tuggyne) 2009-12-10 13:20:25 PST
(In reply to comment #321)
> The Mail-Redirect 0.7.4 add-in for Thunderbird works fine in TB 2.0.0.23 which
> is why I haven't upgraded to TB3 yet.

As noted by Jonathan Vanherpe in comment #320 (!), the version hosted on mozdev.org works just fine with TB3.0 -- I just tried it with RC3 (yes, I know the final is out; I'm just a bit lazy suddenly), and didn't have any problems. I don't know why AMO doesn't have the proper version, but someone should probably ping the maintainer of the addon.

One note on the addon UX: at present, it does not integrate quite as well with Thunderbird as would be necessary for a core feature, so it would take some additional work to polish this up, as well as the inevitable squeezing and shimming of code necessary to integrate extensions into the trunk. If someone is willing to take on that work, I (and doubtless several hundred others CC'd to this bug) would be more than happy to help test, debug, and comment on design choices.

I suspect that's really what this bug is waiting for -- someone willing to put the effort of moving code into the trunk for this important niche feature. Any volunteers?
Comment 323 Martin Donald 2009-12-10 13:48:21 PST
Thanks to everyone who pointed me to mozdev.org to get the add-on mail-redirect-0.7.4. I downloaded this from mailredirect.mozdev.org and the redirect works fine now using TB 3.0b4.

Thanks again
Comment 324 Stephan Petersen 2010-01-24 23:27:19 PST
I can't believe TB3 still doesn't have a built-in redirection function on board. What are the developers thinking???
Comment 325 M.J.G. 2010-01-25 01:04:13 PST
Perhaps they think either or both of:

- The feature is available as an extension.
- If someone needs it in trunk he or she sure would be submitting a patch which does that, right?

Bugzilla is for technical discussions, not for whining.

Michael
Comment 326 Jason Airlie 2010-01-25 12:06:34 PST
Is there a possibility of making this an Official Addon? Meaning, an addon that MozMessaging will commit to keeping up to date? It doesn't have to be included by default. Being able to rely on an addon removes, in my mind at least, much of the need for a feature to be in trunk.
Comment 327 Rein 2010-03-12 02:44:13 PST
Do I understand the following correctly:
the add-on does not work with Thunderbird 3.03?
Anyway, in my case I cannot see any result.

And can I conclude that if it does work, it does not leave the info line as it was originally.
It's only about hidden info in the header.
My co-worker on her computer receives a lot of email which are actually directed to me. If thy are forwarded normally I can't see in the info line who send it originally. And the reply goes to the wrong person (but I believe this add-on should solve that problem).
So: what I need is an unchanged "from" in the info line of the message.

The common way in Outlook to solve this problem is to send an email as a file.
Thunderbird has the strange way of not seeing an .eml file as a file, but as a part of a message. This way you cannot move the file to it's folder.

Does this problem belong here? Sorry if it isn't. But where can I ask it elsewhere?
Comment 328 Herre de Jonge 2010-03-12 04:42:37 PST
(In reply to comment #327)
> Do I understand the following correctly:
> the add-on does not work with Thunderbird 3.03?
> Anyway, in my case I cannot see any result.

The add-on "Mail Redirect v0.7.4" works correctly with TB 3.03.

> And can I conclude that if it does work, it does not leave the info line as it
> was originally.

It leaves all information in the header as it was. For the person you redirect it to it looks as if he has received a BCC. However in the headers is some data is added about resending.

> It's only about hidden info in the header.

From this you can see that the message has been bounced instead of sent as a BCC.

> My co-worker on her computer receives a lot of email which are actually
> directed to me. [ -- deleted -- ]

Then this is the add-on for you.

But still the question remains whether this functionality should be built-in directly or not.
Comment 329 Rein 2010-03-12 07:02:03 PST
Maybe I'm stupid how I try and how I look I see no difference at all with the normal forwarding. Not even the reply function works (to the original sender).
May I conclude that it's not working on my computer?
Or is there an easy check?

Anyway, I doubt if the add-on is useful, because BCC has the same problem: it looks as if the forwarder is the sender....
Comment 330 Rein 2010-03-12 07:17:02 PST
More confused:

Discovered that maybe the add-on I pickid op from the main site was the old version.
So I downloaded the file mentioned above and with the link above, and got the warning:
Mail Redirect 0.7.4 kon niet worden geïnstalleerd omdat het niet compatibel is met Thunderbird 3.0.3.
Which of course is Dutch - it could not be installed because it was not compatible. But it was  this file: mailredirect extension working in TB 2.0 (mailredirect_patched_fo_TB2.xpi)
The file mailredirect-0.7.4-tb3-20091118.xpi gave no problems, but, again, doesn't do anything... as far as I can tell.
Comment 331 Neil Turner 2010-03-12 07:24:01 PST
Rein - I think your question is more suited for http://www.mozilla.org/support/ .
Comment 332 Rimas Kudelis 2010-03-12 07:54:14 PST
Rein:
http://mailredirect.mozdev.org/, see section "Thunderbird 3 support".

Note: after you install this extension, make sure there's a "Redirect" button in the toolbar. This extension does not alter any functions of the default buttons.
Comment 333 Ludovic Hirlimann [:Usul] 2010-09-06 03:58:14 PDT
*** Bug 593439 has been marked as a duplicate of this bug. ***
Comment 334 Peter Flynn 2010-09-07 01:33:41 PDT
Perhaps the single most important reason for adding this to the TB core is that since I updated to the 3.0.6 that comes with Ubuntu 10.4, the Redirect add-on has been unavailable because it hasn't been updated. Redirect is core functionality for professional use of email: its absence is a basic reason for TB being rejected.
Comment 335 Neil Turner 2010-09-07 01:45:19 PDT
(In reply to comment #334)
> Perhaps the single most important reason for adding this to the TB core is that
> since I updated to the 3.0.6 that comes with Ubuntu 10.4, the Redirect add-on
> has been unavailable because it hasn't been updated. Redirect is core
> functionality for professional use of email: its absence is a basic reason for
> TB being rejected.

Make sure you are using the latest Mail Redirect addon from http://mailredirect.mozdev.org/ which works with Thunderbird 3.1.2.
Comment 336 karlsen 2010-09-07 01:56:27 PDT
(In reply to comment #334)
> Perhaps the single most important reason for adding this to the TB core is that
> since I updated to the 3.0.6 that comes with Ubuntu 10.4, the Redirect add-on
> has been unavailable because it hasn't been updated.

I did not test the current mailredirect-Add-On (0.7.6.1 from 2010-09-04) with TB 3.0.x but according to the changelog it should work from version 0.7.4 on <http://mailredirect.mozdev.org/source.html#changelog>.

If not, the current main developer Ronald Wahl is quite responsive in adding supported version numbers if that is all that's needed. 

> Redirect is core
> functionality for professional use of email: its absence is a basic reason for
> TB being rejected.

I still like this feature to be part of the TB/Seamonkey core.
Comment 337 Rein 2010-09-07 02:29:33 PDT
Quite sad that there is no warning what so ever that there IS a version for 3.1.2.
When you get the message that redirect will be lost with installing 3.1.2 you believe it.
I even looked here and found no comment on that issue.

Is there a way to communicate to users that an update IS available?
Or even better, make it a official ad-on of Thunderbird?
I agree that this feature is ESSENTIAL for Thunderbird!
Comment 338 Rein 2010-09-07 02:31:59 PDT
After posting this mail I got all the email adresses where the post is send to.
Even the ones which are excluded.
That is a real bug .... I hope
Comment 339 karlsen 2010-09-07 02:48:01 PDT
(In reply to comment #337)
> Quite sad that there is no warning what so ever that there IS a version for
> 3.1.2.
> When you get the message that redirect will be lost with installing 3.1.2 you
> believe it.
> I even looked here and found no comment on that issue.
> 
> Is there a way to communicate to users that an update IS available?

Well, I believe that with the latest version (if it is installed in TB) the automatic add-on update is enabled for mailredirect. So in the future TB either check at update time if there is a newer version or if not available might check in the future if a version has become available at some later time.

Of course that does not help with all the older version of mailredirect installed.
Comment 340 Peter Flynn 2010-09-07 04:52:42 PDT
Thank you all very much, that works fine.
It certainly would be more sensible if this was automated.
Better still if it was added to the core...
Comment 341 Mugros 2010-09-22 01:59:42 PDT
The addon is working, but there is a big flaw with the latest versions of TB. The redirected emails are not marked with an icon.

Anyway, make this a core functionality.
It's a pity that something basic like this isn't included after sitting in the bug tracker for 10 years, although someone managed to hack it into an extension long ago.
But i gave up hope long ago. It's not worth to talk about enhancements.
Comment 342 Le Gluon du Net 2010-10-13 05:56:10 PDT
I 'm agree with other people here that said this feature have to be implement in the core program.

LGDN.
Comment 343 Ludovic Hirlimann [:Usul] 2010-10-14 03:00:46 PDT
*** Bug 216047 has been marked as a duplicate of this bug. ***
Comment 344 plop 2011-01-05 11:55:19 PST
Any plugin similar to https://addons.mozilla.org/en-US/thunderbird/addon/550/ that would be compatible with TB3 ? and, coming TB4 ?
Comment 345 Ben Bucksch (:BenB) 2011-01-06 02:32:35 PST
Discussion about addons is offtopic here. Please discuss on addons.mozilla.org, the mozilla.support.* groups, or mozillazine.
Comment 346 David E. Ross 2011-01-08 10:32:57 PST
It appears that existing extensions are no longer valid workarounds for this RFE.  Thus, attention should be given to implementing the changes in the basic, "vanilla" Thunderbird.
Comment 347 TGOS 2011-01-10 03:26:33 PST
What the "add-on supporter" don't understand here is that to many people bouncing and redirecting mails is CORE FUNCTIONALITY of a mail client and you don't implement core functionality via an add-on that may break with any new release. By that argumentation, why does Thunderbird even support forwarding of e-mails. We could implement forwarding via an add-on, too, but nobody would ever even consider doing so, because forwarding is also core functionality.
Comment 348 Glutton.Vidal 2011-07-17 22:36:21 PDT
So - why we have to discuss or beg over 10 years, that mail redirect get a core part as in other mail programs, too?
Comment 349 Herre de Jonge 2011-07-17 23:57:31 PDT
Not enough votes? Not enough priority? (And there is an add-on, so the people who want to do it are able to.) For me this enhancement is more important than the change in GUI of TB5... How can it's priority be boosted?
Comment 350 plop 2011-07-18 01:36:07 PDT
Herre, after money, there is only "private services" left :)

TB5 on rails already ? but TB3 still have bugs, and features broken compared to TB 1.5 ... why the hell do they make new release and just break what used to work, instead of improving things and fixing bugs ?

Let's go back to bed, and dream about TB 1.6 ...
Comment 351 Tony Mechelynck [:tonymec] 2011-07-18 21:22:59 PDT
(In reply to comment #350) and also most of the other recent comments:
[...]
> Let's go back to bed, and dream about TB 1.6 ...

Maybe that's the best you can do: whining here won't get the bug fixed — if anything, it will move developers *away* from fixing it. (Y'know anyone with deep knowledge of the Mozilla code who's willing to read 350 comments before even starting work? I don't.)

If some bug (including, but not limited to, this one) isn't moving as fast as you want it to, get your hands into the grease and help fixing it yourself, or at least (by commenting elsewhere, e.g. in newsgroups), find someone who is willing and able to do it. Complaining from the side rails in the bug itself will get you nowhere.
Comment 352 plop 2011-07-19 02:05:08 PDT
There is nothing to do, no hands to put in grease, no dirty work any left. Code is already written, plugins are available. All Moz team have to do is to merge existing source code for plugins into main trunk. No need to enrole us and reinvent the wheel. Nothing to develop. Just merge existing code !!!

It's virtually already fixed ! We just need the fix to be merged !

Grab one of the many plugins that does (or used to do it in close or far past), grab sources, and merge to trunk.

We don't need developers to fix anything. We need admins to merge code.

350 coms in 12 years, that's less than one message every 12 days; I have seen Gentoo bugs fixed in 8 comms in 12 minutes (from bug appearance, to merge of fix to public server). You are whining about 350 comms. We are whining about 12 years to merge existing fix.

Hope i can quit this bug without removing vote ...
Comment 353 Glutton.Vidal 2011-07-19 02:26:33 PDT
How long has it needed to integrate Firefox Sync (Weave) into Seamonkey core code?
Comment 354 Glutton.Vidal 2011-07-19 02:28:44 PDT
How long has it needed to integrate Firefox Sync (Weave) into Seamonkey core code (for comparison)?
Comment 355 sergyj 2011-09-10 05:29:52 PDT
Hi guys.
When redirecting the letter, the headers Resent-To, Resent-Date etc. make duplicated. If one more time redirecting the letter, more headers are added.
Comment 356 Glutton.Vidal 2011-10-17 18:43:21 PDT
Redirecting doesn't work at both notebooks no more ... it seem to send the mails and save the typical redirect symbol, but no emails arrive since hours. I have tested three email addresses at both devices with several emails. The emails stays somewhere in the nowhereland ...
Comment 357 Glutton.Vidal 2011-10-17 18:46:48 PDT
Redirecting doesn't work at both notebooks no more ... it seems to send the mails and save the typical redirect symbol in the email folder, but no emails have arrived since hours. I have tested three email addresses at both devices with several emails. The emails stays somewhere in the nowhereland ...
Comment 358 Ben Bucksch (:BenB) 2011-10-18 03:30:31 PDT
Glutton.Vidal, there is no redirect in base Thunderbird, that's what this bug is about. If you are talking about an addon/extension, please reach the forum or author of that extension.
Comment 359 klonos 2012-10-13 22:43:14 PDT
tl:dr...

Is this the same as bug 492179??
Comment 360 Onno Ekker [:nONoNonO UTC+1] 2012-10-14 00:54:45 PDT
No, it's not quite the same.
That bug is about resending an already sent message to the same recipients again, while this bug is about redirecting a received message to other recipients.
You could use redirect to resend a sent message to the same recipients too, but that would result in a slightly different mail with differen headers.
Comment 361 klonos 2012-10-14 14:08:04 PDT
Ok Onno, got it. Thanx for taking the time to reply.
Comment 362 Jo Hermans 2012-12-05 11:27:36 PST
*** Bug 818440 has been marked as a duplicate of this bug. ***
Comment 363 plop 2012-12-05 12:40:39 PST
So ... it takes more than 13 years to implement a bounce, while it's a basic feature of Pine and mutt, and an add-on was available for 1.5 ?

Rally looks to me like ... what are basic features for all other MUA are ... so complex for the Moz team that they are faster and quicker to implement tabs, transparency, multi-threading, locks, handle CSS, and support theme management ?

HELL, WE ARE TALKING ABOUT BOUNCE !!! TAKE THE DAMN MESSAGE, AND SEND IT AS IS TO THE SMTP !!!

cat message.msg | sed '[add a for: rule here]' | mail
Comment 364 Herre de Jonge 2012-12-06 05:11:58 PST
The add-on is still available (see URL field in the bug description), but it should be core functionality.

Is there a way to push this bug/whish higher up the "todo-list"? Or is the only way voting and are the almost 300 votes not enough to accomplish that?
Comment 365 Blake Winton (:bwinton) (:☕️) 2012-12-06 06:43:46 PST
(In reply to Herre de Jonge from comment #364)
> Is there a way to push this bug/whish higher up the "todo-list"? Or is the
> only way voting and are the almost 300 votes not enough to accomplish that?

I think many of the commenters here are making the invalid assumption that there is some sort of Thunderbird Team who is explicitly ignoring this bug in favour of working on other things.  Let me assure you that there is no team.  There is no todo-list.  There are only volunteers who will work on whatever they feel like working on.  And that set of volunteers includes all of you reading this comment.

So, having hopefully cleared that up, the only ways I see for anyone to push this bug forward are to:
a) convince a developer that they should try to fix it (which will be made harder by the tone of the previous 364 comments), or
b) decide that it's enough of an annoyance for one of you to attempt to fix it yourself (in which case I would be more than happy to help any of you get started).

If any of the people reading this do want to take a stab at fixing this bug, please feel free to email me (at my bugzilla address), and I will help however I can.

Thanks,
Blake.
Comment 366 plop 2012-12-09 07:10:36 PST
Blake, I feel deeply concerned by your message. Yes I really think that the team is ignoring some bugs. For two reasons:
- there is a Moz team, who have been set up to contribute to the product quality
- 2 years ago I had read that the team was composed of 99% volunteers, and a few core permanent paid developpers: the Moz Fundation collects money in order to be able to pay full time dev and ensure a minimal quality of service and product.

Quality is more important to me than the number of claimed features. I don't mind about changelogs and adding (broken) features if the base product just does not work. I did not bookmark the page that was telling about paid dev, but it was an official message from the Moz fundation.

So, your message is right about the 99% volunteers, but that's not what you seem to say: you seem to say that there are only volunteers: 100%. Whole != most. So to me, your comment 365 is wrong from the second line.
Comment 367 Onno Ekker [:nONoNonO UTC+1] 2014-01-02 14:26:45 PST
The extension moved from mozdev to sourceforge a while ago, so I'm updating the URL…
Comment 368 pic.asc.iitb 2014-02-02 05:16:14 PST
Onno,  RFC http://www.ietf.org/rfc/rfc2822.txt and the original request at the top of this message seems to imply that the person who is doing the resending should know to whom the resent has been done. Currenty a green arrow (similar to forward) is added, but there seems to be no annotation in the original email (owned by the first recipient) that will recall to whom the resent was done.  

Any comments?
Comment 369 Onno Ekker [:nONoNonO UTC+1] 2014-02-03 02:51:12 PST
Sorry, but this bug is not the right place to discuss my add-on. Please see my address on the website, send to the mailing list or file a bug on my project's bug tracking system...

You can configure Mail Redirect to save a copy of each redirected mail in your sent folder (which only works when you have setup your account to save messages in the sent folder).

So you see your redirected messages in your sent folder and you can view the source to see who you have redirected the message to0, or you can add resent-to to the pref mailnews.headers.extraExpandedHeaders to view the headers in the header pane.

Note You need to log in before you can comment on or make changes to this bug.